/* 
 *
 *
 */
module gtk;

/* Records */

struct GtkRequisition
{
  gint16 width;
  gint16 height;
};

struct GtkAllocation
{
  gint16 x;
  gint16 y;
  guint16 width;
  guint16 height;
};

struct GtkWidgetAuxInfo
{
  gint16  x;
  gint16  y;
  gint16 width;
  gint16 height;
};


void gtk_x_version(out guint major, out guint minor, out guint micro);

/* GtkSignal */
gchar* gtk_signal_name(guint signal_id);
void gtk_signal_emit_stop_by_name(GtkObject* object, gchar* name);
void gtk_signal_disconnect(GtkObject* object, guint handler_id);
void gtk_signal_handler_block(GtkObject* object, guint handler_id);
void gtk_signal_handler_unblock(GtkObject* object, guint handler_id);

/* GtkAccelLabel -> GtkLabel */
new GtkAccelLabel* gtk_accel_label_new(gchar* string);
guint gtk_accel_label_get_accel_width(GtkAccelLabel* accel_label);
void gtk_accel_label_set_accel_widget(GtkAccelLabel* accel_label, GtkWidget* accel_widget);
gboolean gtk_accel_label_refetch(GtkAccelLabel* accel_label);

/* GtkAccelGroup -> C-STRUCT !!! */
gboolean gtk_accelerator_valid(guint keyval, GdkModifierType modifiers);
void gtk_accelerator_parse(gchar* accelerator, out guint accelerator_key, out GdkModifierType accelerator_mods);
gchar* gtk_accelerator_name(guint accelerator_key, GdkModifierType accelerator_mods);
void gtk_accelerator_set_default_mod_mask(GdkModifierType default_mod_mask);
guint gtk_accelerator_get_default_mod_mask(void);
new GtkAccelGroup* gtk_accel_group_new(void);
GtkAccelGroup* gtk_accel_group_get_default(void);
GtkAccelGroup* gtk_accel_group_ref(GtkAccelGroup* accel_group);
void gtk_accel_group_unref(GtkAccelGroup* accel_group);
void gtk_accel_group_lock(GtkAccelGroup* accel_group);
void gtk_accel_group_unlock(GtkAccelGroup* accel_group);
gboolean gtk_accel_groups_activate(GtkObject* object, guint accel_key, GdkModifierType accel_mods);

/* GtkAdjustment -> GtkData */
new GtkAdjustment* gtk_adjustment_new(gfloat value, gfloat lower, gfloat upper, gfloat step_increment, gfloat page_increment, gfloat page_size);
void gtk_adjustment_changed(GtkAdjustment* adjustment);
void gtk_adjustment_value_changed(GtkAdjustment* adjustment);
void gtk_adjustment_clamp_page(GtkAdjustment* adjustment, gfloat lower, gfloat upper);
void gtk_adjustment_set_value(GtkAdjustment* adjustment, gfloat value);
gfloat GtkAdjustment->lower;
gfloat GtkAdjustment->upper;
gfloat GtkAdjustment->value;
gfloat GtkAdjustment->step_increment;
gfloat GtkAdjustment->page_increment;
gfloat GtkAdjustment->page_size;

/* GtkAlignment -> GtkBin */
new GtkAlignment* gtk_alignment_new(gfloat xalign, gfloat yalign, gfloat xscale, gfloat yscale);
void gtk_alignment_set(GtkAlignment* alignment, gfloat xalign, gfloat yalign, gfloat xscale, gfloat yscale);

/* GtkArrow -> GtkMisc */
new GtkArrow* gtk_arrow_new(GtkArrowType arrow_type, GtkShadowType shadow_type);
void gtk_arrow_set(GtkArrow* arrow, GtkArrowType arrow_type, GtkShadowType shadow_type);

/* GtkAspectFrame */
new GtkAspectFrame* gtk_aspect_frame_new(gchar* label, gfloat xalign, gfloat yalign, gfloat ratio, gboolean obey_child);
void gtk_aspect_frame_set(GtkAspectFrame* aspect_frame, gfloat xalign, gfloat yalign, gfloat ratio, gboolean obey_child);

/* GtkBin */
GtkWidget* GtkBin->child;

/* GtkBox -> GtkContainer */
void gtk_box_pack_start(GtkBox* box, GtkWidget* child, gboolean expand, gboolean fill, guint padding);
void gtk_box_pack_end(GtkBox* box, GtkWidget* child, gboolean expand, gboolean fill, guint padding);
void gtk_box_pack_start_defaults(GtkBox* box, GtkWidget* widget);
void gtk_box_pack_end_defaults(GtkBox* box, GtkWidget* widget);
void gtk_box_set_homogeneous(GtkBox* box, gboolean homogeneous);
void gtk_box_set_spacing(GtkBox* box, gint spacing);
void gtk_box_reorder_child(GtkBox* box, GtkWidget* child, gint position);
void gtk_box_query_child_packing(GtkBox* box, out GtkWidget* child, 
				 out gboolean expand, out gboolean fill, 
				 out guint padding, 
				 out GtkPackType pack_type);
void gtk_box_set_child_packing(GtkBox* box, GtkWidget* child, 
			       gboolean expand, gboolean fill, 
			       guint padding, 
			       GtkPackType pack_type);

/* GtkButton -> GtkBin 
 * Signals:
 *     pressed   ( GtkButton* )
 *     released  ( GtkButton* )
 *     clicked   ( GtkButton* )
 *     enter     ( GtkButton* )
 *     leave     ( GtkButton* )
 *     
 */
new GtkButton* gtk_button_new(void);
new GtkButton* gtk_button_new_with_label(gchar* label);
void gtk_button_pressed(GtkButton* button);
void gtk_button_released(GtkButton* button);
void gtk_button_clicked(GtkButton* button);
void gtk_button_enter(GtkButton* button);
void gtk_button_leave(GtkButton* button);
void gtk_button_set_relief(GtkButton* button, GtkReliefStyle newstyle);
GtkReliefStyle gtk_button_get_relief(GtkButton* button);

/* GtkButtonBox -> GtkBox */
void gtk_button_box_get_child_size_default(out gint min_width, out gint min_height);
void gtk_button_box_get_child_ipadding_default(out gint ipad_x, out gint ipad_y);
gint gtk_button_box_get_spacing(GtkButtonBox* button_box);
GtkButtonBoxStyle gtk_button_box_get_layout(GtkButtonBox* button_box);
void gtk_button_box_get_child_size(GtkButtonBox* button_box, out gint min_width, out gint min_height);
void gtk_button_box_get_child_ipadding(GtkButtonBox* button_box, out gint ipad_x, out gint ipad_y);
void gtk_button_box_set_spacing(GtkButtonBox* button_box, gint spacing);
void gtk_button_box_set_layout(GtkButtonBox* button_box, GtkButtonBoxStyle layout_style);
void gtk_button_box_set_child_size(GtkButtonBox* button_box, gint min_width, gint min_height);
void gtk_button_box_set_child_ipadding(GtkButtonBox* button_box, gint ipad_x, gint ipad_y);

/* GtkCList -> GtkContainer */
new GtkCList* gtk_clist_new(gint columns);
new GtkCList* gtk_clist_new_with_titles(gint columns, gchar** titles);
void gtk_clist_set_hadjustment(GtkCList* clist, GtkAdjustment* adjustment);
void gtk_clist_set_vadjustment(GtkCList* clist, GtkAdjustment* adjustment);
GtkAdjustment* gtk_clist_get_hadjustment(GtkCList* clist);
GtkAdjustment* gtk_clist_get_vadjustment(GtkCList* clist);
void gtk_clist_set_shadow_type(GtkCList* clist, GtkShadowType type);
void gtk_clist_set_selection_mode(GtkCList* clist, GtkSelectionMode mode);
void gtk_clist_set_reorderable(GtkCList* clist, gboolean reorderable);
void gtk_clist_set_use_drag_icons(GtkCList* clist, gboolean use_icons);
void gtk_clist_set_button_actions(GtkCList* clist, guint button, 
				  guint button_actions);
void gtk_clist_freeze(GtkCList* clist);
void gtk_clist_thaw(GtkCList* clist);
void gtk_clist_column_titles_show(GtkCList* clist);
void gtk_clist_column_titles_hide(GtkCList* clist);
void gtk_clist_column_title_active(GtkCList* clist, gint column);
void gtk_clist_column_title_passive(GtkCList* clist, gint column);
void gtk_clist_column_titles_active(GtkCList* clist);
void gtk_clist_column_titles_passive(GtkCList* clist);
void gtk_clist_set_column_title(GtkCList* clist, gint column, gchar* title);
gchar* gtk_clist_get_column_title(GtkCList* clist, gint column);
void gtk_clist_set_column_widget(GtkCList* clist, gint column, GtkWidget* widget);
GtkWidget* gtk_clist_get_column_widget(GtkCList* clist, gint column);
void gtk_clist_set_column_justification(GtkCList* clist, gint column, GtkJustification justification);
void gtk_clist_set_column_visibility(GtkCList* clist, gint column, gboolean visible);
void gtk_clist_set_column_resizeable(GtkCList* clist, gint column, gboolean resizeable);
void gtk_clist_set_column_auto_resize(GtkCList* clist, gint column, gboolean auto_resize);
gint gtk_clist_columns_autosize(GtkCList* clist);
gint gtk_clist_optimal_column_width(GtkCList* clist, gint column);
void gtk_clist_set_column_width(GtkCList* clist, gint column, gint width);
void gtk_clist_set_column_min_width(GtkCList* clist, gint column, gint min_width);
void gtk_clist_set_column_max_width(GtkCList* clist, gint column, gint max_width);
void gtk_clist_set_row_height(GtkCList* clist, guint height);
void gtk_clist_moveto(GtkCList* clist, gint row, gint column, gfloat row_align, gfloat col_align);
GtkVisibility gtk_clist_row_is_visible(GtkCList* clist, gint row);
GtkCellType gtk_clist_get_cell_type(GtkCList* clist, gint row, gint column);
void gtk_clist_set_text(GtkCList* clist, gint row, gint column, gchar* text);
gint gtk_clist_get_text(GtkCList* clist, gint row, gint column, out gchar* text);
void gtk_clist_set_pixmap(GtkCList* clist, gint row, gint column, GdkPixmap* pixmap, GdkBitmap* mask);
gint gtk_clist_get_pixmap(GtkCList* clist, gint row, gint column, out GdkPixmap* pixmap, out GdkBitmap* mask);
void gtk_clist_set_pixtext(GtkCList* clist, gint row, gint column, gchar* text, guint spacing, GdkPixmap* pixmap, GdkBitmap* mask);
gint gtk_clist_get_pixtext(GtkCList* clist, gint row, gint column, out gchar* text, out guint spacing, out GdkPixmap* pixmap, out GdkBitmap* mask);
void gtk_clist_set_foreground(GtkCList* clist, gint row, GdkColor* color);
void gtk_clist_set_background(GtkCList* clist, gint row, GdkColor* color);
void gtk_clist_set_cell_style(GtkCList* clist, gint row, gint column, GtkStyle* style);
GtkStyle* gtk_clist_get_cell_style(GtkCList* clist, gint row, gint column);
void gtk_clist_set_row_style(GtkCList* clist, gint row, GtkStyle* style);
GtkStyle* gtk_clist_get_row_style(GtkCList* clist, gint row);
void gtk_clist_set_shift(GtkCList* clist, gint row, gint column, gint vertical, gint horizontal);
void gtk_clist_set_selectable(GtkCList* clist, gint row, gboolean selectable);
gboolean gtk_clist_get_selectable(GtkCList* clist, gint row);
gint gtk_clist_prepend(GtkCList* clist, gchar** text);
gint gtk_clist_append(GtkCList* clist, gchar** text);
gint gtk_clist_insert(GtkCList* clist, gint row, gchar** text);
void gtk_clist_remove(GtkCList* clist, gint row);
gpointer gtk_clist_get_row_data(GtkCList* clist, gint row);
gint gtk_clist_find_row_from_data(GtkCList* clist, gpointer data);
void gtk_clist_select_row(GtkCList* clist, gint row, gint column);
void gtk_clist_unselect_row(GtkCList* clist, gint row, gint column);
void gtk_clist_undo_selection(GtkCList* clist);
void gtk_clist_clear(GtkCList* clist);
gint gtk_clist_get_selection_info(GtkCList* clist, gint x, gint y, out gint row, out gint column);
void gtk_clist_select_all(GtkCList* clist);
void gtk_clist_unselect_all(GtkCList* clist);
void gtk_clist_swap_rows(GtkCList* clist, gint row1, gint row2);
void gtk_clist_row_move(GtkCList* clist, gint source_row, gint dest_row);
void gtk_clist_set_sort_column(GtkCList* clist, gint column);
void gtk_clist_set_sort_type(GtkCList* clist, GtkSortType sort_type);
void gtk_clist_sort(GtkCList* clist);
void gtk_clist_set_auto_sort(GtkCList* clist, gboolean auto_sort);

/* GtkCTree */
new GtkCTree* gtk_ctree_new(gint columns, gint tree_column);
new GtkCTree* gtk_ctree_new_with_titles(gint columns, gint tree_column,
					gchar** titles);
void gtk_ctree_construct(GtkCTree* ctree, gint columns, gint tree_column, 
			 gchar** titles);

/* GtkCalendar */
new GtkCalendar* gtk_calendar_new(void);
gint gtk_calendar_select_month(GtkCalendar* calendar, guint month, guint year);
void gtk_calendar_select_day(GtkCalendar* calendar, guint day);
gint gtk_calendar_mark_day(GtkCalendar* calendar, guint day);
gint gtk_calendar_unmark_day(GtkCalendar* calendar, guint day);
void gtk_calendar_clear_marks(GtkCalendar* calendar);
void gtk_calendar_display_options(GtkCalendar* calendar, GtkCalendarDisplayOptions flags);
void gtk_calendar_get_date(GtkCalendar* calendar, out guint year, out guint month, out guint day);
void gtk_calendar_freeze(GtkCalendar* calendar);
void gtk_calendar_thaw(GtkCalendar* calendar);

/* GtkCheckButton */
new GtkCheckButton* gtk_check_button_new(void);
new GtkCheckButton* gtk_check_button_new_with_label(gchar* label);

/* GtkCheckMenuItem */
new GtkCheckMenuItem* gtk_check_menu_item_new(void);
new GtkCheckMenuItem* gtk_check_menu_item_new_with_label(gchar* label);
void gtk_check_menu_item_set_active(GtkCheckMenuItem* check_menu_item, gboolean is_active);
void gtk_check_menu_item_set_show_toggle(GtkCheckMenuItem* check_menu_item, gboolean always);
void gtk_check_menu_item_toggled(GtkCheckMenuItem* check_menu_item);

/* GtkColorSelection */
new GtkColorSelection* gtk_color_selection_new(void);
void gtk_color_selection_set_update_policy(GtkColorSelection* color_selection, GtkUpdateType policy);
void gtk_color_selection_set_opacity(GtkColorSelection* color_selection, gint use_opacity);

/* GtkColorSelectionDialog */
new GtkColorSelectionDialog* gtk_color_selection_dialog_new(gchar* title);
GtkWidget* GtkColorSelectionDialog->colorsel;
GtkWidget* GtkColorSelectionDialog->ok_button;
GtkWidget* GtkColorSelectionDialog->cancel_button;
GtkWidget* GtkColorSelectionDialog->help_button;

/* GtkCombo */
new GtkCombo* gtk_combo_new(void);
void gtk_combo_set_value_in_list(GtkCombo* combo, gint val, gint ok_if_empty);
void gtk_combo_set_use_arrows(GtkCombo* combo, gint val);
void gtk_combo_set_use_arrows_always(GtkCombo* combo, gint val);
void gtk_combo_set_case_sensitive(GtkCombo* combo, gint val);
void gtk_combo_set_item_string(GtkCombo* combo, GtkItem* item, gchar* item_value);
void gtk_combo_set_popdown_strings(GtkCombo* combo, GList* strings);
void gtk_combo_disable_activate(GtkCombo* combo);
GtkWidget* GtkCombo->entry;
GtkWidget* GtkCombo->list;

/* GtkContainer -> GtkWidget */
void gtk_container_set_border_width(GtkContainer* container, guint border_width);
void gtk_container_add(GtkContainer* container, GtkWidget* widget);
void gtk_container_remove(GtkContainer* container, GtkWidget* widget);
void gtk_container_set_resize_mode(GtkContainer* container, GtkResizeMode resize_mode);
void gtk_container_check_resize(GtkContainer* container);

void gtk_container_child_setv (GtkContainer *container, GtkWidget *child,
			       guint n_args, GtkArg *args);
void gtk_container_child_getv (GtkContainer *container, GtkWidget *child,
			       guint n_args, GtkArg *args);

/* GtkCurve */
new GtkCurve* gtk_curve_new(void);
void gtk_curve_reset(GtkCurve* curve);
void gtk_curve_set_gamma(GtkCurve* curve, gfloat gamma);
void gtk_curve_set_range(GtkCurve* curve, gfloat min_x, gfloat max_x, gfloat min_y, gfloat max_y);
void gtk_curve_set_vector(GtkCurve* curve, gint veclen, gfloat* vector);
void gtk_curve_set_curve_type(GtkCurve* curve, GtkCurveType type);

/* GtkDialog */
new GtkDialog* gtk_dialog_new(void);
GtkWidget* GtkDialog->vbox;
GtkWidget* GtkDialog->action_area;

/* GtkDrawingArea */
new GtkDrawingArea* gtk_drawing_area_new(void);
void gtk_drawing_area_size(GtkDrawingArea* drawing_area, gint width, gint height);
void gtk_editable_select_region(GtkEditable* editable, gint start, gint end);
void gtk_editable_insert_text(GtkEditable* editable, gchar* new_text, gint new_text_length, inout gint position);
void gtk_editable_delete_text(GtkEditable* editable, gint start_pos, gint end_pos);
gchar* gtk_editable_get_chars(GtkEditable* editable, gint start_pos, gint end_pos);
void gtk_editable_cut_clipboard(GtkEditable* editable);
void gtk_editable_copy_clipboard(GtkEditable* editable);
void gtk_editable_paste_clipboard(GtkEditable* editable);
void gtk_editable_delete_selection(GtkEditable* editable);
void gtk_editable_set_position(GtkEditable* editable, gint position);
gint gtk_editable_get_position(GtkEditable* editable);
void gtk_editable_set_editable(GtkEditable* editable, gboolean is_editable);

/* GtkEntry */
new GtkEntry* gtk_entry_new(void);

/* GtkEntry */
new GtkEntry* gtk_entry_new_with_max_length(guint max);
void gtk_entry_set_text(GtkEntry* entry, gchar* text);
void gtk_entry_append_text(GtkEntry* entry, gchar* text);
void gtk_entry_prepend_text(GtkEntry* entry, gchar* text);
void gtk_entry_set_position(GtkEntry* entry, gint position);
gchar* gtk_entry_get_text(GtkEntry* entry);
void gtk_entry_select_region(GtkEntry* entry, gint start, gint end);
void gtk_entry_set_visibility(GtkEntry* entry, gboolean visible);
void gtk_entry_set_editable(GtkEntry* entry, gboolean editable);
void gtk_entry_set_max_length(GtkEntry* entry, guint max);
gint GtkEntry->text_length;

/* GtkEventBox */
new GtkEventBox* gtk_event_box_new(void);

/* GtkFileSelection */
new GtkFileSelection* gtk_file_selection_new(gchar* title);
GtkWidget* GtkFileSelection->ok_button;
GtkWidget* GtkFileSelection->cancel_button;
void gtk_file_selection_set_filename(GtkFileSelection* file_selection, gchar* filename);
gchar* gtk_file_selection_get_filename(GtkFileSelection* file_selection);
void gtk_file_selection_complete(GtkFileSelection* file_selection, gchar* pattern);
void gtk_file_selection_show_fileop_buttons(GtkFileSelection* file_selection);
void gtk_file_selection_hide_fileop_buttons(GtkFileSelection* file_selection);

/* GtkFixed */
new GtkFixed* gtk_fixed_new(void);
void gtk_fixed_put(GtkFixed* fixed, GtkWidget* widget, gint x, gint y);
void gtk_fixed_move(GtkFixed* fixed, GtkWidget* widget, gint x, gint y);

/* GtkFontSelection */
new GtkFontSelection* gtk_font_selection_new(void);
gchar* gtk_font_selection_get_font_name(GtkFontSelection* font_selection);
GdkFont* gtk_font_selection_get_font(GtkFontSelection* font_selection);
gboolean gtk_font_selection_set_font_name(GtkFontSelection* font_selection, gchar* fontname);
gchar* gtk_font_selection_get_preview_text(GtkFontSelection* font_selection);
void gtk_font_selection_set_preview_text(GtkFontSelection* font_selection, gchar* text);

/* GtkFontSelectionDialog */
new GtkFontSelectionDialog* gtk_font_selection_dialog_new(gchar* title);
gchar* gtk_font_selection_dialog_get_font_name(GtkFontSelectionDialog* font_selection_dialog);
GdkFont* gtk_font_selection_dialog_get_font(GtkFontSelectionDialog* font_selection_dialog);
gboolean gtk_font_selection_dialog_set_font_name(GtkFontSelectionDialog* font_selection_dialog, gchar* fontname);
gchar* gtk_font_selection_dialog_get_preview_text(GtkFontSelectionDialog* font_selection_dialog);
void gtk_font_selection_dialog_set_preview_text(GtkFontSelectionDialog* font_selection_dialog, gchar* text);
GtkWidget* GtkFontSelectionDialog->fontsel;
GtkWidget* GtkFontSelectionDialog->main_vbox;
GtkWidget* GtkFontSelectionDialog->action_area;
GtkWidget* GtkFontSelectionDialog->ok_button;
GtkWidget* GtkFontSelectionDialog->apply_button;
GtkWidget* GtkFontSelectionDialog->cancel_button;

/* GtkFrame */
new GtkFrame* gtk_frame_new(gchar* label);
void gtk_frame_set_label(GtkFrame* frame, gchar* label);
void gtk_frame_set_label_align(GtkFrame* frame, gfloat xalign, gfloat yalign);
void gtk_frame_set_shadow_type(GtkFrame* frame, GtkShadowType type);

/* GtkHBox */
new GtkHBox* gtk_hbox_new(gboolean homogeneous, gint spacing);

/* GtkHButtonBox */
new GtkHButtonBox* gtk_hbutton_box_new(void);
gint gtk_hbutton_box_get_spacing_default(void);
GtkButtonBoxStyle gtk_hbutton_box_get_layout_default(void);
void gtk_hbutton_box_set_spacing_default(gint spacing);
void gtk_hbutton_box_set_layout_default(GtkButtonBoxStyle layout);

/* GtkHPaned */
new GtkHPaned* gtk_hpaned_new(void);

/* GtkHRuler */
new GtkHRuler* gtk_hruler_new(void);

/* GtkHScale */
new GtkHScale* gtk_hscale_new(GtkAdjustment* adjustment);

/* GtkHScrollbar */
new GtkHScrollbar* gtk_hscrollbar_new(GtkAdjustment* adjustment);

/* GtkHSeparator */
new GtkHSeparator* gtk_hseparator_new(void);

/* GtkHandleBox */
new GtkHandleBox* gtk_handle_box_new(void);
void gtk_handle_box_set_shadow_type(GtkHandleBox* handle_box, GtkShadowType type);
void gtk_handle_box_set_handle_position(GtkHandleBox* handle_box, GtkPositionType position);
void gtk_handle_box_set_snap_edge(GtkHandleBox* handle_box, GtkPositionType edge);

/* GtkInputDialog */
new GtkInputDialog* gtk_input_dialog_new(void);
GtkWidget* GtkInputDialog->close_button;
GtkWidget* GtkInputDialog->save_button;

/* GtkItem -> GtkBin */
void gtk_item_select(GtkItem* item);
void gtk_item_deselect(GtkItem* item);
void gtk_item_toggle(GtkItem* item);

/* GtkLabel -> GtkMisc */
new GtkLabel* gtk_label_new(gchar* str);
void gtk_label_set_text(GtkLabel* label, gchar* str);
void gtk_label_set_justify(GtkLabel* label, GtkJustification jtype);
void gtk_label_set_pattern(GtkLabel* label, gchar* pattern);
void gtk_label_set_line_wrap(GtkLabel* label, gboolean wrap);
gchar* GtkLabel->label;

/* GtkLayout */
new GtkLayout* gtk_layout_new(GtkAdjustment* hadjustment, GtkAdjustment* vadjustment);
void gtk_layout_put(GtkLayout* layout, GtkWidget* widget, gint x, gint y);
void gtk_layout_move(GtkLayout* layout, GtkWidget* widget, gint x, gint y);
void gtk_layout_set_size(GtkLayout* layout, guint width, guint height);
GtkAdjustment* gtk_layout_get_hadjustment(GtkLayout* layout);
GtkAdjustment* gtk_layout_get_vadjustment(GtkLayout* layout);
void gtk_layout_set_hadjustment(GtkLayout* layout, GtkAdjustment* adjustment);
void gtk_layout_set_vadjustment(GtkLayout* layout, GtkAdjustment* adjustment);
void gtk_layout_freeze(GtkLayout* layout);
void gtk_layout_thaw(GtkLayout* layout);

/* GtkList */
new GtkList* gtk_list_new(void);
void gtk_list_insert_items(GtkList* list, GList* items, gint position);
void gtk_list_append_items(GtkList* list, GList* items);
void gtk_list_prepend_items(GtkList* list, GList* items);
void gtk_list_remove_items(GtkList* list, GList* items);
void gtk_list_remove_items_no_unref(GtkList* list, GList* items);
void gtk_list_clear_items(GtkList* list, gint start, gint end);
void gtk_list_select_item(GtkList* list, gint item);
void gtk_list_unselect_item(GtkList* list, gint item);
void gtk_list_select_child(GtkList* list, GtkWidget* child);
void gtk_list_unselect_child(GtkList* list, GtkWidget* child);
gint gtk_list_child_position(GtkList* list, GtkWidget* child);
void gtk_list_set_selection_mode(GtkList* list, GtkSelectionMode mode);
void gtk_list_extend_selection(GtkList* list, GtkScrollType scroll_type, gfloat position, gboolean auto_start_selection);
void gtk_list_start_selection(GtkList* list);
void gtk_list_end_selection(GtkList* list);
void gtk_list_select_all(GtkList* list);
void gtk_list_unselect_all(GtkList* list);
void gtk_list_scroll_horizontal(GtkList* list, GtkScrollType scroll_type, gfloat position);
void gtk_list_scroll_vertical(GtkList* list, GtkScrollType scroll_type, gfloat position);
void gtk_list_toggle_add_mode(GtkList* list);
void gtk_list_toggle_focus_row(GtkList* list);
void gtk_list_toggle_row(GtkList* list, GtkWidget* item);
void gtk_list_undo_selection(GtkList* list);
void gtk_list_end_drag_selection(GtkList* list);

/* GtkListItem */
new GtkListItem* gtk_list_item_new(void);
new GtkListItem* gtk_list_item_new_with_label(gchar* label);
void gtk_list_item_select(GtkListItem* list_item);
void gtk_list_item_deselect(GtkListItem* list_item);

/* GtkMenu */
new GtkMenu* gtk_menu_new(void);
void gtk_menu_append(GtkMenu* menu, GtkWidget* child);
void gtk_menu_prepend(GtkMenu* menu, GtkWidget* child);
void gtk_menu_insert(GtkMenu* menu, GtkWidget* child, gint position);
void gtk_menu_reposition(GtkMenu* menu);
void gtk_menu_popdown(GtkMenu* menu);
GtkWidget* gtk_menu_get_active(GtkMenu* menu);
void gtk_menu_set_active(GtkMenu* menu, guint index);
void gtk_menu_set_accel_group(GtkMenu* menu, GtkAccelGroup* accel_group);
GtkAccelGroup* gtk_menu_get_accel_group(GtkMenu* menu);
GtkAccelGroup* gtk_menu_get_uline_accel_group(GtkMenu* menu);
GtkAccelGroup* gtk_menu_ensure_uline_accel_group(GtkMenu* menu);
void gtk_menu_detach(GtkMenu* menu);
GtkWidget* gtk_menu_get_attach_widget(GtkMenu* menu);
void gtk_menu_set_tearoff_state(GtkMenu* menu, gboolean torn_off);
void gtk_menu_set_title(GtkMenu* menu, gchar* title);
void gtk_menu_reorder_child(GtkMenu* menu, GtkWidget* child, gint position);

/* GtkMenuBar */
new GtkMenuBar* gtk_menu_bar_new(void);
void gtk_menu_bar_append(GtkMenuBar* menu_bar, GtkWidget* child);
void gtk_menu_bar_prepend(GtkMenuBar* menu_bar, GtkWidget* child);
void gtk_menu_bar_insert(GtkMenuBar* menu_bar, GtkWidget* child, gint position);
void gtk_menu_bar_set_shadow_type(GtkMenuBar* menu_bar, GtkShadowType type);

/* GtkMenuItem */
new GtkMenuItem* gtk_menu_item_new(void);
new GtkMenuItem* gtk_menu_item_new_with_label(gchar* label);
void gtk_menu_item_set_submenu(GtkMenuItem* menu_item, GtkWidget* submenu);
void gtk_menu_item_remove_submenu(GtkMenuItem* menu_item);
void gtk_menu_item_set_placement(GtkMenuItem* menu_item, GtkSubmenuPlacement placement);
void gtk_menu_item_configure(GtkMenuItem* menu_item, gint show_toggle_indicator, gint show_submenu_indicator);
void gtk_menu_item_select(GtkMenuItem* menu_item);
void gtk_menu_item_deselect(GtkMenuItem* menu_item);
void gtk_menu_item_activate(GtkMenuItem* menu_item);
void gtk_menu_item_right_justify(GtkMenuItem* menu_item);
GtkWidget* GtkMenuItem->submenu;
void gtk_menu_shell_append(GtkMenuShell* menu_shell, GtkWidget* child);
void gtk_menu_shell_prepend(GtkMenuShell* menu_shell, GtkWidget* child);
void gtk_menu_shell_insert(GtkMenuShell* menu_shell, GtkWidget* child, gint position);
void gtk_menu_shell_deactivate(GtkMenuShell* menu_shell);
void gtk_menu_shell_select_item(GtkMenuShell* menu_shell, GtkWidget* menu_item);
void gtk_menu_shell_deselect(GtkMenuShell* menu_shell);
void gtk_menu_shell_activate_item(GtkMenuShell* menu_shell, GtkWidget* menu_item, gboolean force_deactivate);

/* GtkMisc ->GtkWidget */
void gtk_misc_set_alignment(GtkMisc* misc, gfloat xalign, gfloat yalign);
void gtk_misc_set_padding(GtkMisc* misc, gint xpad, gint ypad);

/* GtkNotebook -> GtkContainer */
new GtkNotebook* gtk_notebook_new(void);
gboolean GtkNotebook->show_tabs;
gboolean GtkNotebook->homogeneous;
gboolean GtkNotebook->show_border;
gint GtkNotebook->tab_pos;
void gtk_notebook_append_page(GtkNotebook* notebook, GtkWidget* child, GtkWidget* tab_label);
void gtk_notebook_append_page_menu(GtkNotebook* notebook, GtkWidget* child, GtkWidget* tab_label, GtkWidget* menu_label);
void gtk_notebook_prepend_page(GtkNotebook* notebook, GtkWidget* child, GtkWidget* tab_label);
void gtk_notebook_prepend_page_menu(GtkNotebook* notebook, GtkWidget* child, GtkWidget* tab_label, GtkWidget* menu_label);
void gtk_notebook_insert_page(GtkNotebook* notebook, GtkWidget* child, GtkWidget* tab_label, gint position);
void gtk_notebook_insert_page_menu(GtkNotebook* notebook, GtkWidget* child, GtkWidget* tab_label, GtkWidget* menu_label, gint position);
void gtk_notebook_remove_page(GtkNotebook* notebook, gint page_num);
gint gtk_notebook_get_current_page(GtkNotebook* notebook);
GtkWidget* gtk_notebook_get_nth_page(GtkNotebook* notebook, gint page_num);
gint gtk_notebook_page_num(GtkNotebook* notebook, GtkWidget* child);
void gtk_notebook_set_page(GtkNotebook* notebook, gint page_num);
void gtk_notebook_next_page(GtkNotebook* notebook);
void gtk_notebook_prev_page(GtkNotebook* notebook);
void gtk_notebook_set_show_border(GtkNotebook* notebook, gboolean show_border);
void gtk_notebook_set_show_tabs(GtkNotebook* notebook, gboolean show_tabs);
void gtk_notebook_set_tab_pos(GtkNotebook* notebook, GtkPositionType pos);
void gtk_notebook_set_homogeneous_tabs(GtkNotebook* notebook, gboolean homogeneous);
void gtk_notebook_set_tab_border(GtkNotebook* notebook, guint border_width);
void gtk_notebook_set_tab_hborder(GtkNotebook* notebook, guint tab_hborder);
void gtk_notebook_set_tab_vborder(GtkNotebook* notebook, guint tab_vborder);
void gtk_notebook_set_scrollable(GtkNotebook* notebook, gboolean scrollable);
void gtk_notebook_popup_enable(GtkNotebook* notebook);
void gtk_notebook_popup_disable(GtkNotebook* notebook);
GtkWidget* gtk_notebook_get_tab_label(GtkNotebook* notebook, GtkWidget* child);
void gtk_notebook_set_tab_label(GtkNotebook* notebook, GtkWidget* child, GtkWidget* tab_label);
void gtk_notebook_set_tab_label_text(GtkNotebook* notebook, GtkWidget* child, gchar* tab_text);
GtkWidget* gtk_notebook_get_menu_label(GtkNotebook* notebook, GtkWidget* child);
void gtk_notebook_set_menu_label(GtkNotebook* notebook, GtkWidget* child, GtkWidget* menu_label);
void gtk_notebook_set_menu_label_text(GtkNotebook* notebook, GtkWidget* child, gchar* menu_text);
void gtk_notebook_query_tab_label_packing(GtkNotebook* notebook, GtkWidget* child, out gboolean expand, out gboolean fill, out GtkPackType pack_type);
void gtk_notebook_set_tab_label_packing(GtkNotebook* notebook, GtkWidget* child, gboolean expand, gboolean fill, GtkPackType pack_type);
void gtk_notebook_reorder_child(GtkNotebook* notebook, GtkWidget* child, gint position);
void gtk_object_destroy(GtkObject* object);
void gtk_object_ref(GtkObject* object);
void gtk_object_unref(GtkObject* object);
void gtk_x_object_set_user_data(GtkObject* object, ETERM* data);
ETERM* gtk_x_object_get_user_data(GtkObject* object);
void gtk_x_object_set_data(GtkObject* object, gchar* key, ETERM* data);
ETERM* gtk_x_object_get_data(GtkObject* object, gchar* key);
ETERM* gtk_x_container_children(GtkContainer* container);
guint gtk_object_get_flags(GtkObject* object);
void gtk_object_set_flags(GtkObject* object, guint flags);
void gtk_object_unset_flags(GtkObject* object, guint flags);

new GtkObject* gtk_object_newv(GtkType object_type,
			       guint n_args,
			       GtkArg *args);
void gtk_object_setv (GtkObject *object, guint n_args, GtkArg *args);
void gtk_object_getv (GtkObject *object, guint n_args, inout GtkArg *args);

/* GtkOptionMenu */
new GtkOptionMenu* gtk_option_menu_new(void);
GtkWidget* gtk_option_menu_get_menu(GtkOptionMenu* option_menu);
void gtk_option_menu_set_menu(GtkOptionMenu* option_menu, GtkWidget* menu);
void gtk_option_menu_remove_menu(GtkOptionMenu* option_menu);
void gtk_option_menu_set_history(GtkOptionMenu* option_menu, guint index);

/* GtkPacker */
new GtkPacker* gtk_packer_new(void);
void gtk_packer_add_defaults(GtkPacker* packer, GtkWidget* child, GtkSideType side, GtkAnchorType anchor, GtkPackerOptions options);
void gtk_packer_add(GtkPacker* packer, GtkWidget* child, GtkSideType side, GtkAnchorType anchor, GtkPackerOptions options, guint border_width, guint pad_x, guint pad_y, guint i_pad_x, guint i_pad_y);
void gtk_packer_set_child_packing(GtkPacker* packer, GtkWidget* child, GtkSideType side, GtkAnchorType anchor, GtkPackerOptions options, guint border_width, guint pad_x, guint pad_y, guint i_pad_x, guint i_pad_y);
void gtk_packer_reorder_child(GtkPacker* packer, GtkWidget* child, gint position);
void gtk_packer_set_spacing(GtkPacker* packer, guint spacing);
void gtk_packer_set_default_border_width(GtkPacker* packer, guint border);
void gtk_packer_set_default_pad(GtkPacker* packer, guint pad_x, guint pad_y);
void gtk_packer_set_default_ipad(GtkPacker* packer, guint i_pad_x, guint i_pad_y);
void gtk_paned_add1(GtkPaned* paned, GtkWidget* child);
void gtk_paned_add2(GtkPaned* paned, GtkWidget* child);
void gtk_paned_pack1(GtkPaned* paned, GtkWidget* child, gboolean resize, gboolean shrink);
void gtk_paned_pack2(GtkPaned* paned, GtkWidget* child, gboolean resize, gboolean shrink);
void gtk_paned_set_position(GtkPaned* paned, gint position);
void gtk_paned_set_handle_size(GtkPaned* paned, guint size);

/* GtkPixmap */
new GtkPixmap* gtk_pixmap_new(GdkPixmap* pixmap, GdkBitmap* mask);
void gtk_pixmap_set(GtkPixmap* pixmap, GdkPixmap* gdkpixmap, GdkBitmap* mask);
void gtk_pixmap_get(GtkPixmap* pixmap, out GdkPixmap* val, out GdkBitmap* mask);
GdkPixmap* GtkPixmap->pixmap;
GdkBitmap* GtkPixmap->mask;
void gtk_pixmap_set_build_insensitive(GtkPixmap* pixmap, guint build);

/* GtkPlug */
new GtkPlug* gtk_plug_new(guint socket_id);
void gtk_plug_construct(GtkPlug* plug, guint socket_id);

/* GtkProgress */
new GtkProgress* gtk_progress_bar_new(void);
new GtkProgress* gtk_progress_bar_new_with_adjustment(GtkAdjustment* adj);
void gtk_progress_set_show_text(GtkProgress* progress, gint show_text);
void gtk_progress_set_text_alignment(GtkProgress* progress, gfloat x_align, gfloat y_align);
void gtk_progress_set_format_string(GtkProgress* progress, gchar* format);
void gtk_progress_set_adjustment(GtkProgress* progress, GtkAdjustment* adjustment);
void gtk_progress_configure(GtkProgress* progress, gfloat value, gfloat min, gfloat max);
void gtk_progress_set_percentage(GtkProgress* progress, gfloat percentage);
void gtk_progress_set_value(GtkProgress* progress, gfloat value);
gfloat gtk_progress_get_value(GtkProgress* progress);
void gtk_progress_set_activity_mode(GtkProgress* progress, guint activity_mode);
gchar* gtk_progress_get_current_text(GtkProgress* progress);
gchar* gtk_progress_get_text_from_value(GtkProgress* progress, gfloat value);
gfloat gtk_progress_get_current_percentage(GtkProgress* progress);
gfloat gtk_progress_get_percentage_from_value(GtkProgress* progress, gfloat value);
GtkAdjustment* GtkProgress->adjustment;
void gtk_progress_bar_set_bar_style(GtkProgressBar* progress_bar, GtkProgressBarStyle style);
void gtk_progress_bar_set_discrete_blocks(GtkProgressBar* progress_bar, guint blocks);
void gtk_progress_bar_set_activity_step(GtkProgressBar* progress_bar, guint step);
void gtk_progress_bar_set_activity_blocks(GtkProgressBar* progress_bar, guint blocks);
void gtk_progress_bar_set_orientation(GtkProgressBar* progress_bar, GtkProgressBarOrientation orientation);
void gtk_progress_bar_update(GtkProgressBar* progress_bar, gfloat percentage);

/* GtkRadioButton */
new GtkRadioButton* gtk_radio_button_new(GSList* group);
new GtkRadioButton* gtk_radio_button_new_from_widget(GtkRadioButton* group);
new GtkRadioButton* gtk_radio_button_new_with_label(GSList* group, gchar* label);
new GtkRadioButton* gtk_radio_button_new_with_label_from_widget(GtkRadioButton* group, gchar* label);
GSList* gtk_radio_button_group(GtkRadioButton* radio_button);
void gtk_radio_button_set_group(GtkRadioButton* radio_button, GSList* group);

/* GtkRadioMenuItem */
new GtkRadioMenuItem* gtk_radio_menu_item_new(GSList* group);
new GtkRadioMenuItem* gtk_radio_menu_item_new_with_label(GSList* group, gchar* label);
GSList* gtk_radio_menu_item_group(GtkRadioMenuItem* radio_menu_item);
void gtk_radio_menu_item_set_group(GtkRadioMenuItem* radio_menu_item, GSList* group);

/* GtkRange */
GtkAdjustment* gtk_range_get_adjustment(GtkRange* range);
void gtk_range_set_update_policy(GtkRange* range, GtkUpdateType policy);
void gtk_range_set_adjustment(GtkRange* range, GtkAdjustment* adjustment);
void gtk_range_draw_background(GtkRange* range);
void gtk_range_clear_background(GtkRange* range);
void gtk_range_draw_trough(GtkRange* range);
void gtk_range_draw_slider(GtkRange* range);
void gtk_range_draw_step_forw(GtkRange* range);
void gtk_range_draw_step_back(GtkRange* range);
void gtk_range_slider_update(GtkRange* range);
gint gtk_range_trough_click(GtkRange* range, gint x, gint y, out gfloat jump_perc);
void gtk_range_default_hslider_update(GtkRange* range);
void gtk_range_default_vslider_update(GtkRange* range);
gint gtk_range_default_htrough_click(GtkRange* range, gint x, gint y, out gfloat jump_perc);
gint gtk_range_default_vtrough_click(GtkRange* range, gint x, gint y, out gfloat jump_perc);
void gtk_range_default_hmotion(GtkRange* range, gint xdelta, gint ydelta);
void gtk_range_default_vmotion(GtkRange* range, gint xdelta, gint ydelta);

/* GtkRulter */
void gtk_ruler_set_metric(GtkRuler* ruler, GtkMetricType metric);
void gtk_ruler_set_range(GtkRuler* ruler, gfloat lower, gfloat upper, gfloat position, gfloat max_size);
void gtk_ruler_draw_ticks(GtkRuler* ruler);
void gtk_ruler_draw_pos(GtkRuler* ruler);

/* GtkScale */
void gtk_scale_set_digits(GtkScale* scale, gint digits);
void gtk_scale_set_draw_value(GtkScale* scale, gboolean draw_value);
void gtk_scale_set_value_pos(GtkScale* scale, GtkPositionType pos);
gint gtk_scale_get_value_width(GtkScale* scale);
void gtk_scale_draw_value(GtkScale* scale);

/* GtkScrolledWindow */
new GtkScrolledWindow* gtk_scrolled_window_new(GtkAdjustment* hadjustment, GtkAdjustment* vadjustment);
void gtk_scrolled_window_set_hadjustment(GtkScrolledWindow* scrolled_window, GtkAdjustment* hadjustment);
void gtk_scrolled_window_set_vadjustment(GtkScrolledWindow* scrolled_window, GtkAdjustment* hadjustment);
GtkAdjustment* gtk_scrolled_window_get_hadjustment(GtkScrolledWindow* scrolled_window);
GtkAdjustment* gtk_scrolled_window_get_vadjustment(GtkScrolledWindow* scrolled_window);
void gtk_scrolled_window_set_policy(GtkScrolledWindow* scrolled_window, GtkPolicyType hscrollbar_policy, GtkPolicyType vscrollbar_policy);
void gtk_scrolled_window_set_placement(GtkScrolledWindow* scrolled_window, GtkCornerType window_placement);
void gtk_scrolled_window_add_with_viewport(GtkScrolledWindow* scrolled_window, GtkWidget* child);

/* GtkSpinButton */
new GtkSpinButton* gtk_spin_button_new(GtkAdjustment* adjustment, gfloat climb_rate, guint digits);
void gtk_spin_button_configure(GtkSpinButton* spin_button, GtkAdjustment* adjustment, gfloat climb_rate, guint digits);
void gtk_spin_button_set_adjustment(GtkSpinButton* spin_button, GtkAdjustment* adjustment);
GtkAdjustment* gtk_spin_button_get_adjustment(GtkSpinButton* spin_button);
void gtk_spin_button_set_digits(GtkSpinButton* spin_button, guint digits);
gfloat gtk_spin_button_get_value_as_float(GtkSpinButton* spin_button);
gint gtk_spin_button_get_value_as_int(GtkSpinButton* spin_button);
void gtk_spin_button_set_value(GtkSpinButton* spin_button, gfloat value);
void gtk_spin_button_set_update_policy(GtkSpinButton* spin_button, GtkSpinButtonUpdatePolicy policy);
void gtk_spin_button_set_numeric(GtkSpinButton* spin_button, gboolean numeric);
void gtk_spin_button_spin(GtkSpinButton* spin_button, GtkSpinType direction, gfloat increment);
void gtk_spin_button_set_wrap(GtkSpinButton* spin_button, gboolean wrap);
void gtk_spin_button_set_shadow_type(GtkSpinButton* spin_button, GtkShadowType shadow_type);
void gtk_spin_button_set_snap_to_ticks(GtkSpinButton* spin_button, gboolean snap_to_ticks);
void gtk_spin_button_update(GtkSpinButton* spin_button);
guint GtkSpinButton->digits;

/* GtkStatusbar */
new GtkStatusbar* gtk_statusbar_new(void);
guint gtk_statusbar_get_context_id(GtkStatusbar* statusbar, gchar* context_description);
guint gtk_statusbar_push(GtkStatusbar* statusbar, guint context_id, gchar* text);
void gtk_statusbar_pop(GtkStatusbar* statusbar, guint context_id);
void gtk_statusbar_remove(GtkStatusbar* statusbar, guint context_id, guint message_id);


/* GtkStyle -> C-STRUCT (1.2) !!! */
GdkColor* &GtkStyle->fg[GtkStateType state];
GdkColor* &GtkStyle->bg[GtkStateType state];
GdkColor* &GtkStyle->light[GtkStateType state];
GdkColor* &GtkStyle->dark[GtkStateType state];
GdkColor* &GtkStyle->mid[GtkStateType state];
GdkColor* &GtkStyle->text[GtkStateType state];
GdkColor* &GtkStyle->base[GtkStateType state];
GdkColor* &GtkStyle->black;
GdkColor* &GtkStyle->white;
GdkFont*  GtkStyle->font;
GdkGC*    GtkStyle->fg_gc[GtkStateType state];
GdkGC*    GtkStyle->bg_gc[GtkStateType state];
GdkGC*    GtkStyle->light_gc[GtkStateType state];
GdkGC*    GtkStyle->dark_gc[GtkStateType state];
GdkGC*    GtkStyle->mid_gc[GtkStateType state];
GdkGC*    GtkStyle->text_gc[GtkStateType state];
GdkGC*    GtkStyle->base_gc[GtkStateType state];
GdkGC*    GtkStyle->black_gc;
GdkGC*    GtkStyle->white_gc;
GdkPixmap* GtkStyle->bg_pixmap[GtkStateType state];

new GtkStyle* gtk_style_new(void);
GtkStyle* gtk_style_copy(GtkStyle* style);
GtkStyle* gtk_style_attach(GtkStyle* style, GdkWindow* window);
void gtk_style_detach(GtkStyle* style);
GtkStyle* gtk_style_ref(GtkStyle* style);
void gtk_style_unref(GtkStyle* style);
void gtk_style_set_background(GtkStyle* style, GdkWindow* window, GtkStateType state);
void gtk_draw_hline(GtkStyle* style, GdkWindow* window, GtkStateType state_type, gint x1, gint x2, gint y);
void gtk_draw_vline(GtkStyle* style, GdkWindow* window, GtkStateType state_type, gint y1, gint y2, gint x);
void gtk_draw_shadow(GtkStyle* style, GdkWindow* window, GtkStateType state_type, GtkShadowType shadow_type, gint x, gint y, gint width, gint height);
void gtk_draw_polygon(GtkStyle* style, GdkWindow* window, GtkStateType state_type, GtkShadowType shadow_type, GdkPoint* points, gint npoints, gboolean fill);
void gtk_draw_arrow(GtkStyle* style, GdkWindow* window, GtkStateType state_type, GtkShadowType shadow_type, GtkArrowType arrow_type, gboolean fill, gint x, gint y, gint width, gint height);
void gtk_draw_diamond(GtkStyle* style, GdkWindow* window, GtkStateType state_type, GtkShadowType shadow_type, gint x, gint y, gint width, gint height);
void gtk_draw_oval(GtkStyle* style, GdkWindow* window, GtkStateType state_type, GtkShadowType shadow_type, gint x, gint y, gint width, gint height);
void gtk_draw_string(GtkStyle* style, GdkWindow* window, GtkStateType state_type, gint x, gint y, gchar* string);
void gtk_draw_box(GtkStyle* style, GdkWindow* window, GtkStateType state_type, GtkShadowType shadow_type, gint x, gint y, gint width, gint height);
void gtk_paint_hline(GtkStyle* style, GdkWindow* window, GtkStateType state_type, GdkRectangle* area, GtkWidget* widget, gchar* detail, gint x1, gint x2, gint y);
void gtk_paint_vline(GtkStyle* style, GdkWindow* window, GtkStateType state_type, GdkRectangle* area, GtkWidget* widget, gchar* detail, gint y1, gint y2, gint x);
void gtk_paint_shadow(GtkStyle* style, GdkWindow* window, GtkStateType state_type, GtkShadowType shadow_type, GdkRectangle* area, GtkWidget* widget, gchar* detail, gint x, gint y, gint width, gint height);
void gtk_paint_polygon(GtkStyle* style, GdkWindow* window, GtkStateType state_type, GtkShadowType shadow_type, GdkRectangle* area, GtkWidget* widget, gchar* detail, GdkPoint* points, gint npoints, gboolean fill);
void gtk_paint_arrow(GtkStyle* style, GdkWindow* window, GtkStateType state_type, GtkShadowType shadow_type, GdkRectangle* area, GtkWidget* widget, gchar* detail, GtkArrowType arrow_type, gboolean fill, gint x, gint y, gint width, gint height);
void gtk_paint_diamond(GtkStyle* style, GdkWindow* window, GtkStateType state_type, GtkShadowType shadow_type, GdkRectangle* area, GtkWidget* widget, gchar* detail, gint x, gint y, gint width, gint height);
void gtk_paint_oval(GtkStyle* style, GdkWindow* window, GtkStateType state_type, GtkShadowType shadow_type, GdkRectangle* area, GtkWidget* widget, gchar* detail, gint x, gint y, gint width, gint height);
void gtk_paint_string(GtkStyle* style, GdkWindow* window, GtkStateType state_type, GdkRectangle* area, GtkWidget* widget, gchar* detail, gint x, gint y, gchar* string);
void gtk_paint_box(GtkStyle* style, GdkWindow* window, GtkStateType state_type, GtkShadowType shadow_type, GdkRectangle* area, GtkWidget* widget, gchar* detail, gint x, gint y, gint width, gint height);
void gtk_paint_flat_box(GtkStyle* style, GdkWindow* window, GtkStateType state_type, GtkShadowType shadow_type, GdkRectangle* area, GtkWidget* widget, gchar* detail, gint x, gint y, gint width, gint height);
void gtk_paint_check(GtkStyle* style, GdkWindow* window, GtkStateType state_type, GtkShadowType shadow_type, GdkRectangle* area, GtkWidget* widget, gchar* detail, gint x, gint y, gint width, gint height);
void gtk_paint_option(GtkStyle* style, GdkWindow* window, GtkStateType state_type, GtkShadowType shadow_type, GdkRectangle* area, GtkWidget* widget, gchar* detail, gint x, gint y, gint width, gint height);
void gtk_paint_cross(GtkStyle* style, GdkWindow* window, GtkStateType state_type, GtkShadowType shadow_type, GdkRectangle* area, GtkWidget* widget, gchar* detail, gint x, gint y, gint width, gint height);
void gtk_paint_ramp(GtkStyle* style, GdkWindow* window, GtkStateType state_type, GtkShadowType shadow_type, GdkRectangle* area, GtkWidget* widget, gchar* detail, GtkArrowType arrow_type, gint x, gint y, gint width, gint height);
void gtk_paint_tab(GtkStyle* style, GdkWindow* window, GtkStateType state_type, GtkShadowType shadow_type, GdkRectangle* area, GtkWidget* widget, gchar* detail, gint x, gint y, gint width, gint height);
void gtk_paint_shadow_gap(GtkStyle* style, GdkWindow* window, GtkStateType state_type, GtkShadowType shadow_type, GdkRectangle* area, GtkWidget* widget, gchar* detail, gint x, gint y, gint width, gint height, GtkPositionType gap_side, gint gap_x, gint gap_width);
void gtk_paint_box_gap(GtkStyle* style, GdkWindow* window, GtkStateType state_type, GtkShadowType shadow_type, GdkRectangle* area, GtkWidget* widget, gchar* detail, gint x, gint y, gint width, gint height, GtkPositionType gap_side, gint gap_x, gint gap_width);
void gtk_paint_extension(GtkStyle* style, GdkWindow* window, GtkStateType state_type, GtkShadowType shadow_type, GdkRectangle* area, GtkWidget* widget, gchar* detail, gint x, gint y, gint width, gint height, GtkPositionType gap_side);
void gtk_paint_focus(GtkStyle* style, GdkWindow* window, GdkRectangle* area, GtkWidget* widget, gchar* detail, gint x, gint y, gint width, gint height);
void gtk_paint_slider(GtkStyle* style, GdkWindow* window, GtkStateType state_type, GtkShadowType shadow_type, GdkRectangle* area, GtkWidget* widget, gchar* detail, gint x, gint y, gint width, gint height, GtkOrientation orientation);
void gtk_paint_handle(GtkStyle* style, GdkWindow* window, GtkStateType state_type, GtkShadowType shadow_type, GdkRectangle* area, GtkWidget* widget, gchar* detail, gint x, gint y, gint width, gint height, GtkOrientation orientation);

/* GtkRcStyle */
gchar*     GtkRcStyle->name;
gchar*     GtkRcStyle->bg_pixmap_name[GtkStateType state];
GtkRcFlags GtkRcStyle->color_flags[GtkStateType state];
GdkColor*  &GtkRcStyle->fg[GtkStateType state];
GdkColor*  &GtkRcStyle->bg[GtkStateType state];
GdkColor*  &GtkRcStyle->text[GtkStateType state];
GdkColor*  &GtkRcStyle->base[GtkStateType state];

void gtk_rc_init(void);
void gtk_rc_add_default_file(gchar* filename);
void gtk_rc_set_default_files(gchar** filenames);
gchar** gtk_rc_get_default_files(void);
void gtk_rc_parse(gchar* filename);
void gtk_rc_parse_string(gchar* rc_string);
gboolean gtk_rc_reparse_all(void);
GtkStyle* gtk_rc_get_style(GtkWidget* widget);
void gtk_rc_add_widget_name_style(GtkRcStyle* rc_style, gchar* pattern);
void gtk_rc_add_widget_class_style(GtkRcStyle* rc_style, gchar* pattern);
void gtk_rc_add_class_style(GtkRcStyle* rc_style, gchar* pattern);

new GtkRcStyle* gtk_rc_style_new(void);
void gtk_rc_style_ref(GtkRcStyle* rc_style);
void gtk_rc_style_unref(GtkRcStyle* rc_style);

/* GtkTable */
new GtkTable* gtk_table_new(guint rows, guint columns, gboolean homogeneous);
void gtk_table_resize(GtkTable* table, guint rows, guint columns);
void gtk_table_attach(GtkTable* table, GtkWidget* child, guint left_attach, guint right_attach, guint top_attach, guint bottom_attach, GtkAttachOptions xoptions, GtkAttachOptions yoptions, guint xpadding, guint ypadding);
void gtk_table_attach_defaults(GtkTable* table, GtkWidget* widget, guint left_attach, guint right_attach, guint top_attach, guint bottom_attach);
void gtk_table_set_row_spacing(GtkTable* table, guint row, guint spacing);
void gtk_table_set_col_spacing(GtkTable* table, guint column, guint spacing);
void gtk_table_set_row_spacings(GtkTable* table, guint spacing);
void gtk_table_set_col_spacings(GtkTable* table, guint spacing);
void gtk_table_set_homogeneous(GtkTable* table, gboolean homogeneous);

/* GtkTearoffMenuItem */
new GtkTearoffMenuItem* gtk_tearoff_menu_item_new(void);

/* GtkText */
new GtkText* gtk_text_new(GtkAdjustment* hadj, GtkAdjustment* vadj);
void gtk_text_set_editable(GtkText* text, gboolean editable);
void gtk_text_set_word_wrap(GtkText* text, gint word_wrap);
void gtk_text_set_line_wrap(GtkText* text, gint line_wrap);
void gtk_text_set_adjustments(GtkText* text, GtkAdjustment* hadj, GtkAdjustment* vadj);
void gtk_text_set_point(GtkText* text, guint index);
guint gtk_text_get_point(GtkText* text);
guint gtk_text_get_length(GtkText* text);
void gtk_text_freeze(GtkText* text);
void gtk_text_thaw(GtkText* text);
void gtk_text_insert(GtkText* text, GdkFont* font, GdkColor* fore, GdkColor* back, gchar* chars, gint length);
gint gtk_text_backward_delete(GtkText* text, guint nchars);
gint gtk_text_forward_delete(GtkText* text, guint nchars);
GtkAdjustment* GtkText->hadj;
GtkAdjustment* GtkText->vadj;

/* GtkToggleButton */
new GtkToggleButton* gtk_toggle_button_new(void);

/* GtkToggleButton */
new GtkToggleButton* gtk_toggle_button_new_with_label(gchar* label);
void gtk_toggle_button_set_mode(GtkToggleButton* toggle_button, gboolean draw_indicator);
void gtk_toggle_button_set_active(GtkToggleButton* toggle_button, gboolean is_active);
gboolean gtk_toggle_button_get_active(GtkToggleButton* toggle_button);
void gtk_toggle_button_toggled(GtkToggleButton* toggle_button);

/* GtkToolbar */
new GtkToolbar* gtk_toolbar_new(GtkOrientation orientation, GtkToolbarStyle style);
void gtk_toolbar_append_space(GtkToolbar* toolbar);
void gtk_toolbar_prepend_space(GtkToolbar* toolbar);
void gtk_toolbar_insert_space(GtkToolbar* toolbar, gint position);
void gtk_toolbar_append_widget(GtkToolbar* toolbar, GtkWidget* widget, gchar* tooltip_text, gchar* tooltip_private_text);
void gtk_toolbar_prepend_widget(GtkToolbar* toolbar, GtkWidget* widget, gchar* tooltip_text, gchar* tooltip_private_text);
void gtk_toolbar_insert_widget(GtkToolbar* toolbar, GtkWidget* widget, gchar* tooltip_text, gchar* tooltip_private_text, gint position);
void gtk_toolbar_set_orientation(GtkToolbar* toolbar, GtkOrientation orientation);
void gtk_toolbar_set_style(GtkToolbar* toolbar, GtkToolbarStyle style);
void gtk_toolbar_set_space_size(GtkToolbar* toolbar, gint space_size);
void gtk_toolbar_set_space_style(GtkToolbar* toolbar, GtkToolbarSpaceStyle space_style);
void gtk_toolbar_set_tooltips(GtkToolbar* toolbar, gint enable);
void gtk_toolbar_set_button_relief(GtkToolbar* toolbar, GtkReliefStyle relief);
GtkReliefStyle gtk_toolbar_get_button_relief(GtkToolbar* toolbar);

/* GtkTooltips */
new GtkTooltips* gtk_tooltips_new(void);
void gtk_tooltips_enable(GtkTooltips* tooltips);
void gtk_tooltips_disable(GtkTooltips* tooltips);
void gtk_tooltips_set_delay(GtkTooltips* tooltips, guint delay);
void gtk_tooltips_set_tip(GtkTooltips* tooltips, GtkWidget* widget, gchar* tip_text, gchar* tip_private);
void gtk_tooltips_set_colors(GtkTooltips* tooltips, GdkColor* background, GdkColor* foreground);
void gtk_tooltips_force_window(GtkTooltips* tooltips);

/* GtkTree */
new GtkTree* gtk_tree_new(void);
void gtk_tree_append(GtkTree* tree, GtkWidget* tree_item);
void gtk_tree_prepend(GtkTree* tree, GtkWidget* tree_item);
void gtk_tree_insert(GtkTree* tree, GtkWidget* tree_item, gint position);
void gtk_tree_remove_items(GtkTree* tree, GList* items);
void gtk_tree_clear_items(GtkTree* tree, gint start, gint end);
void gtk_tree_select_item(GtkTree* tree, gint item);
void gtk_tree_unselect_item(GtkTree* tree, gint item);
void gtk_tree_select_child(GtkTree* tree, GtkWidget* tree_item);
void gtk_tree_unselect_child(GtkTree* tree, GtkWidget* tree_item);
gint gtk_tree_child_position(GtkTree* tree, GtkWidget* child);
void gtk_tree_set_selection_mode(GtkTree* tree, GtkSelectionMode mode);
void gtk_tree_set_view_mode(GtkTree* tree, GtkTreeViewMode mode);
void gtk_tree_set_view_lines(GtkTree* tree, guint flag);

/* GtkTreeItem -> GtkItem */
new GtkTreeItem* gtk_tree_item_new(void);
new GtkTreeItem* gtk_tree_item_new_with_label(gchar* label);
void gtk_tree_item_set_subtree(GtkTreeItem* tree_item, GtkWidget* subtree);
void gtk_tree_item_remove_subtree(GtkTreeItem* tree_item);
void gtk_tree_item_select(GtkTreeItem* tree_item);
void gtk_tree_item_deselect(GtkTreeItem* tree_item);
void gtk_tree_item_expand(GtkTreeItem* tree_item);
void gtk_tree_item_collapse(GtkTreeItem* tree_item);

/* GtkVBox -> GtkBox */
new GtkVBox* gtk_vbox_new(gboolean homogeneous, gint spacing);

/* GtkVButtonBox -> GtkButtonBox */
new GtkVButtonBox* gtk_vbutton_box_new(void);
gint gtk_vbutton_box_get_spacing_default(void);
void gtk_vbutton_box_set_spacing_default(gint spacing);
GtkButtonBoxStyle gtk_vbutton_box_get_layout_default(void);
void gtk_vbutton_box_set_layout_default(GtkButtonBoxStyle layout);

/* GtkVPaned */
new GtkVPaned* gtk_vpaned_new(void);

/* GtkVRuler */
new GtkVRuler* gtk_vruler_new(void);

/* GtkVScale */
new GtkVScale* gtk_vscale_new(GtkAdjustment* adjustment);

/* GtkVScrollbar */
new GtkVScrollbar* gtk_vscrollbar_new(GtkAdjustment* adjustment);

/* GtkVSeparator */
new GtkVSeparator* gtk_vseparator_new(void);

/* GtkViewport */
new GtkViewport* gtk_viewport_new(GtkAdjustment* hadjustment, GtkAdjustment* vadjustment);
GtkAdjustment* gtk_viewport_get_hadjustment(GtkViewport* viewport);
GtkAdjustment* gtk_viewport_get_vadjustment(GtkViewport* viewport);
void gtk_viewport_set_hadjustment(GtkViewport* viewport, GtkAdjustment* adjustment);
void gtk_viewport_set_vadjustment(GtkViewport* viewport, GtkAdjustment* adjustment);
void gtk_viewport_set_shadow_type(GtkViewport* viewport, GtkShadowType type);

/* GtkWidget */

GdkWindow* GtkWidget->window;
GtkWidget* GtkWidget->parent;

new GtkWidget* gtk_widget_newv(GtkType type,
			       guint nargs,
			       GtkArg *args);
void gtk_widget_getv(GtkWidget *widget,
		     guint nargs,
		     GtkArg *args);
void gtk_widget_setv(GtkWidget *widget,
		     guint nargs,
		     GtkArg *args);

void gtk_widget_destroy(GtkWidget* widget);
void gtk_widget_ref(GtkWidget* widget);
void gtk_widget_unref(GtkWidget* widget);
GtkWidgetAuxInfo* gtk_widget_get_aux_info(GtkWidget* widget);

GtkAllocation*  &GtkWidget->allocation;
GtkRequisition* &GtkWidget->requisition;

void gtk_widget_unparent(GtkWidget* widget);
void gtk_widget_show(GtkWidget* widget);
void gtk_widget_show_now(GtkWidget* widget);
void gtk_widget_hide(GtkWidget* widget);
void gtk_widget_show_all(GtkWidget* widget);
void gtk_widget_hide_all(GtkWidget* widget);
void gtk_widget_map(GtkWidget* widget);
void gtk_widget_unmap(GtkWidget* widget);
void gtk_widget_realize(GtkWidget* widget);
void gtk_widget_unrealize(GtkWidget* widget);
void gtk_widget_grab_focus(GtkWidget* widget);
void gtk_widget_grab_default(GtkWidget* widget);
void gtk_widget_draw(GtkWidget* widget, GdkRectangle* area);
void gtk_widget_add_accelerator(GtkWidget* widget, gchar* accel_signal, GtkAccelGroup* accel_group, guint accel_key, guint accel_mods, GtkAccelFlags accel_flags);
void gtk_widget_remove_accelerator(GtkWidget* widget, GtkAccelGroup* accel_group, guint accel_key, guint accel_mods);
void gtk_widget_remove_accelerators(GtkWidget* widget, gchar* accel_signal, gboolean visible_only);
guint gtk_widget_accelerator_signal(GtkWidget* widget, GtkAccelGroup* accel_group, guint accel_key, guint accel_mods);
void gtk_widget_lock_accelerators(GtkWidget* widget);
void gtk_widget_unlock_accelerators(GtkWidget* widget);
gboolean gtk_widget_accelerators_locked(GtkWidget* widget);
gboolean gtk_widget_activate(GtkWidget* widget);
void gtk_widget_reparent(GtkWidget* widget, GtkWidget* new_parent);
void gtk_widget_popup(GtkWidget* widget, gint x, gint y);
void gtk_widget_set_name(GtkWidget* widget, gchar* name);
gchar* gtk_widget_get_name(GtkWidget* widget);
void gtk_widget_set_parent_window(GtkWidget* widget, GdkWindow* parent_window);
GdkWindow* gtk_widget_get_parent_window(GtkWidget* widget);
void gtk_widget_set_uposition(GtkWidget* widget, gint x, gint y);
void gtk_widget_set_usize(GtkWidget* widget, gint width, gint height);
void gtk_widget_set_events(GtkWidget* widget, gint events);
void gtk_widget_add_events(GtkWidget* widget, gint events);
GtkWidget* gtk_widget_get_toplevel(GtkWidget* widget);
GdkColormap* gtk_widget_get_colormap(GtkWidget* widget);
GdkVisual* gtk_widget_get_visual(GtkWidget* widget);
void gtk_widget_set_colormap(GtkWidget* widget, GdkColormap* colormap);
void gtk_widget_set_visual(GtkWidget* widget, GdkVisual* visual);
gint gtk_widget_get_events(GtkWidget* widget);
void gtk_widget_get_pointer(GtkWidget* widget, out gint x, out gint y);
gint gtk_widget_is_ancestor(GtkWidget* widget, GtkWidget* ancestor);
gint gtk_widget_hide_on_delete(GtkWidget* widget);
void gtk_widget_set_state(GtkWidget* widget, GtkStateType state);
void gtk_widget_set_sensitive(GtkWidget* widget, gboolean sensitive);
void gtk_widget_set_app_paintable(GtkWidget* widget, gboolean app_paintable);
void gtk_widget_set_style(GtkWidget* widget, GtkStyle* style);
void gtk_widget_set_rc_style(GtkWidget* widget);
void gtk_widget_ensure_style(GtkWidget* widget);
GtkStyle* gtk_widget_get_style(GtkWidget* widget);
void gtk_widget_restore_default_style(GtkWidget* widget);
void gtk_widget_modify_style(GtkWidget* widget, GtkRcStyle* style);
void gtk_widget_set_composite_name(GtkWidget* widget, gchar* name);
gchar* gtk_widget_get_composite_name(GtkWidget* widget);
void gtk_widget_reset_rc_styles(GtkWidget* widget);
void gtk_widget_push_style(GtkStyle* style);
void gtk_widget_push_colormap(GdkColormap* cmap);
void gtk_widget_push_composite_child(void);
void gtk_widget_pop_composite_child(void);
void gtk_widget_pop_style(void);
void gtk_widget_pop_colormap(void);
void gtk_widget_set_default_style(GtkStyle* style);
void gtk_widget_set_default_colormap(GdkColormap* colormap);
GtkStyle* gtk_widget_get_default_style(void);
GdkColormap* gtk_widget_get_default_colormap(void);
GdkVisual* gtk_widget_get_default_visual(void);
void gtk_widget_shape_combine_mask(GtkWidget* widget, GdkBitmap* shape_mask, gint offset_x, gint offset_y);
void gtk_widget_set_flags(GtkWidget* widget, guint flags);
void gtk_widget_unset_flags(GtkWidget* widget, guint flags);
guint gtk_widget_get_flags(GtkWidget* widget);
guint gtk_widget_get_state(GtkWidget* widget);
guint gtk_widget_get_saved_state(GtkWidget* widget);

/* GtkWindow */
new GtkWindow* gtk_window_new(GtkWindowType type);
void gtk_window_set_title(GtkWindow* window, gchar* title);
void gtk_window_set_wmclass(GtkWindow* window, gchar* wmclass_name, gchar* wmclass_class);
void gtk_window_set_policy(GtkWindow* window, gint allow_shrink, gint allow_grow, gint auto_shrink);
void gtk_window_add_accel_group(GtkWindow* window, GtkAccelGroup* accel_group);
void gtk_window_remove_accel_group(GtkWindow* window, GtkAccelGroup* accel_group);
void gtk_window_set_position(GtkWindow* window, GtkWindowPosition position);
gint gtk_window_activate_focus(GtkWindow* window);
gint gtk_window_activate_default(GtkWindow* window);
void gtk_window_set_transient_for(GtkWindow* window, GtkWindow* parent);
void gtk_window_set_default_size(GtkWindow* window, gint width, gint height);
void gtk_window_set_modal(GtkWindow* window, gboolean modal);

/* gtkutils */
GtkType gtk_type_from_name(const gchar *name);
GtkType gtk_type_parent (GtkType type);
gboolean gtk_type_is_a  (GtkType type, GtkType is_a_type);
gchar*  gtk_type_name (GtkType type);
