#ifndef __GTK_DRV_API_H__
#define __GTK_DRV_API_H__

#define GTK_DISABLE_COMPAT_H  /* for checking */
#define GDK_DISABLE_COMPAT_H  /* for checking */

#include <string.h>
#include <gtk/gtk.h>
#include <gtk/gtkinvisible.h>
#include <erl_interface.h>

typedef int  (*FCoder) ();
typedef void (*FFunction) ();
typedef void (*FMarshaller) ();

#define GTK_VERS(a,b,c) (((a) << 16) + ((b) << 8) + (c))

#define INIT_TYPE(name) do { \
  GtkType typeno; \
  typeno = (name); \
 } while(0)

/* SOME FUNCTION MACROS FOR 2.0 */
#if GTK_VERSION >= GTK_VERS(1,3,2)
#define gtk_color_selection_set_opacity gtk_color_selection_set_use_opacity
#endif

/* SOME TYPE MACROS GDK->GTK 1.2 */
#if GTK_VERSION < GTK_VERS(2,0,0)
#define GDK_TYPE_COLOR            GTK_TYPE_GDK_COLOR
#define GDK_TYPE_EVENT            GTK_TYPE_GDK_EVENT
#define GDK_TYPE_FONT             GTK_TYPE_GDK_FONT
#define GDK_TYPE_VISUAL           GTK_TYPE_GDK_VISUAL
#define GDK_TYPE_CURSOR_TYPE      GTK_TYPE_GDK_CURSOR_TYPE
#define GDK_TYPE_FILL             GTK_TYPE_GDK_FILL
#define GDK_TYPE_SUBWINDOW_MODE   GTK_TYPE_GDK_SUBWINDOW_MODE
#define GDK_TYPE_LINE_STYLE       GTK_TYPE_GDK_LINE_STYLE
#define GDK_TYPE_CAP_STYLE        GTK_TYPE_GDK_CAP_STYLE
#define GDK_TYPE_JOIN_STYLE       GTK_TYPE_GDK_JOIN_STYLE
#define GDK_TYPE_FUNCTION         GTK_TYPE_GDK_FUNCTION
#define GDK_TYPE_VISUAL_TYPE      GTK_TYPE_GDK_VISUAL_TYPE
#define GDK_TYPE_MODIFIER_TYPE    GTK_TYPE_GDK_MODIFIER_TYPE
#define GDK_TYPE_DRAG_ACTION      GTK_TYPE_GDK_DRAG_ACTION
#define GDK_TYPE_WINDOW_TYPE      GTK_TYPE_GDK_WINDOW_TYPE
#define GDK_TYPE_WMDECORATION     GTK_TYPE_GDK_WM_DECORATION
#define GDK_TYPE_EXTENSION_MODE   GTK_TYPE_GDK_EXTENSION_MODE
#define GDK_TYPE_INPUT_SOURCE     GTK_TYPE_GDK_INPUT_SOURCE
#define GDK_TYPE_INPUT_MODE       GTK_TYPE_GDK_INPUT_MODE
#define GDK_TYPE_AXIS_USE         GTK_TYPE_GDK_AXIS_USE
#define GDK_TYPE_IMSTYLE          GTK_TYPE_GDK_IM_STYLE
#define GDK_TYPE_WMFUNCTION       GTK_TYPE_GDK_WM_FUNCTION
#define GDK_TYPE_DRAG_PROTOCOL    GTK_TYPE_GDK_DRAG_PROTOCOL
#define GDK_TYPE_EVENT_MASK       GTK_TYPE_GDK_EVENT_MASK
#define GDK_TYPE_PROP_MODE        GTK_TYPE_GDK_PROP_MODE
#endif

/* wrapper for 1.2.8 - 2.0 compatiblity */
#if GTK_VERSION < GTK_VERS(1,3,1)
#define G_TYPE_OBJECT             GTK_TYPE_OBJECT
#define G_TYPE_GTK_POINTER        GTK_TYPE_POINTER
#define GDK_TYPE_WINDOW           GTK_TYPE_GDK_WINDOW
#define GDK_TYPE_COLORMAP         GTK_TYPE_GDK_COLORMAP
#define GDK_TYPE_DRAG_CONTEXT     GTK_TYPE_GDK_DRAG_CONTEXT
#endif

/* FIXME (some broken and then the auto generation problem) */

#ifndef GTK_TYPE_HBUTTON_BOX
#define GTK_TYPE_HBUTTON_BOX (gtk_hbutton_box_get_type ())
#endif

#ifndef GTK_TYPE_VBUTTON_BOX
#define GTK_TYPE_VBUTTON_BOX (gtk_vbutton_box_get_type ())
#endif

#ifndef GTK_TYPE_HRULER
#define GTK_TYPE_HRULER (gtk_hruler_get_type ())
#endif

#ifndef GTK_TYPE_VRULER
#define GTK_TYPE_VRULER (gtk_vruler_get_type ())
#endif

#ifndef GTK_TYPE_HPANED
#define GTK_TYPE_HPANED (gtk_hpaned_get_type())
#endif

#ifndef GTK_TYPE_VPANED
#define GTK_TYPE_VPANED (gtk_vpaned_get_type())
#endif

#ifndef GTK_TYPE_STATUSBAR
#define GTK_TYPE_STATUSBAR (gtk_statusbar_get_type())
#endif

#ifndef GTK_TYPE_PLUG
#define GTK_TYPE_PLUG      (gtk_plug_get_type())
#endif

#ifndef GTK_TYPE_SOCKET
#define GTK_TYPE_SOCKET    (gtk_socket_get_type())
#endif

#ifndef GTK_TYPE_COMBO
#define GTK_TYPE_COMBO  (gtk_combo_get_type())
#endif

#ifndef GTK_TYPE_GAMMA_CURVE
#define GTK_TYPE_GAMMA_CURVE (gtk_gamma_curve_get_type())
#endif

#ifndef GTK_TYPE_INVISIBLE
#define GTK_TYPE_INVISIBLE  (gtk_invisible_get_type())
#endif


extern GtkType GDK_TYPE_BITMAP;
extern GtkType GDK_TYPE_PIXMAP;
extern GtkType GDK_TYPE_IMAGE;
extern GtkType GDK_TYPE_RECTANGLE;
extern GtkType GDK_TYPE_POINT;
extern GtkType GDK_TYPE_SEGMENT;
extern GtkType GDK_TYPE_CURSOR;
extern GtkType GDK_TYPE_WINDOW_ATTR;
extern GtkType GDK_TYPE_GEOMETRY;

#if GTK_VERSION < GTK_VERS(1,3,1)
extern GtkType GDK_TYPE_GC;
extern GtkType GDK_TYPE_DRAWABLE;
extern GtkType GDK_TYPE_ATOM;
#endif

extern GtkType GTK_TYPE_RC_STYLE;
extern GtkType GTK_TYPE_WIDGET_AUX_INFO;
extern GtkType GTK_TYPE_ALLOCATION;
extern GtkType GTK_TYPE_REQUISITION;
extern GtkType GTK_TYPE_ETERM;      /* pointer type */
extern GtkType GTK_TYPE_ARRAY;     /* pointer type */
extern GtkType GTK_TYPE_GLIST;      /* pointer type */
extern GtkType GTK_TYPE_GSLIST;     /* pointer type */
extern GtkType GTK_TYPE_ARG;        /* pointer type */
extern GtkType GTK_TYPE_TYPE;

extern GtkType GTK_TYPE_ARRAY_OF_VOID;
extern GtkType GTK_TYPE_ARRAY_OF_CHAR;
extern GtkType GTK_TYPE_ARRAY_OF_UCHAR;
extern GtkType GTK_TYPE_ARRAY_OF_BOOL;
extern GtkType GTK_TYPE_ARRAY_OF_INT;
extern GtkType GTK_TYPE_ARRAY_OF_UINT;
extern GtkType GTK_TYPE_ARRAY_OF_LONG;
extern GtkType GTK_TYPE_ARRAY_OF_ULONG;
extern GtkType GTK_TYPE_ARRAY_OF_FLOAT;
extern GtkType GTK_TYPE_ARRAY_OF_DOUBLE;
extern GtkType GTK_TYPE_ARRAY_OF_STRING;
extern GtkType GTK_TYPE_ARRAY_OF_ENUM;
extern GtkType GTK_TYPE_ARRAY_OF_FLAGS;
extern GtkType GTK_TYPE_ARRAY_OF_BOXED;
extern GtkType GTK_TYPE_ARRAY_OF_POINTER;
extern GtkType GTK_TYPE_ARRAY_OF_OBJECT;
extern GtkType GDK_TYPE_ARRAY_OF_POINT;
extern GtkType GDK_TYPE_ARRAY_OF_SEGMENT;
extern GtkType GTK_TYPE_ARRAY_OF_ARG;

#if GTK_VERSION >= GTK_VERS(1,3,1)
#define GTK_TYPE_SEQNO(t) G_TYPE_BRANCH_SEQNO((t))
#endif

#define MAX_ID_BUF          256
#define MAX_ID_LEN          255

/* special type for output vectors */
typedef struct {
    GtkType elem_type;
    int     size;
    void*   vector;
} GtkArray;

typedef struct _e_type_info_t {
    gchar *type_name;
    GtkType *type_id;
    GtkType parent;
    const GtkEnumValue *values;
} e_type_info_t;


typedef enum {
    ARG_IN     = 1,
    ARG_OUT    = 2,
    ARG_INOUT  = 3,   /* 1 | 2 !! */
    ARG_ELLIPS = 4
} arg_status_t;

typedef enum {
    Q_NONE     = 0,
    Q_UNSIGNED = 1,
    Q_SIGNED   = 2,
    Q_CONST    = 4
} type_qualifier_t;


typedef struct _e_arg_t {
    GtkType type;
    arg_status_t status;
} e_arg_t;

#define ALIGN_SZ	sizeof(double)

typedef struct _gdrv_mesg_t {
    struct _gdrv_mesg_t* next;  /* next in free list */
    gboolean dynamic;	        /* fixed message or not */
    gint alen;                  /* allocated buffer size */
    gint len;                   /* length of message */
    int  ix;                    /* index */
    guint8 hdr[4];              /* place to format length header */
    guint8 data[ALIGN_SZ];      /* use sizeof(double) for alignment */
} gdrv_mesg_t;

extern void gdrv_mesg_init(void);

extern void*   gdrv_stack_alloc(int n);

extern char*   gdrv_type_to_erlname(GtkType type);

extern char*   gdrv_typename_to_cname(char* dst, char* src);

extern char*   gdrv_type_prefix(char* dst, char* src);
extern char*   gdrv_typename_to_basename(char* dst, char* prefix, char* src);

extern char*   gdrv_ext_to_typeidname(char* name);

extern char*   gdrv_typename_to_typeidname(char* name, int indirection,
					   type_qualifier_t q);

extern GtkType gdrv_type_from_name(char* name, int indirection,
				   arg_status_t status,
				   type_qualifier_t q);

extern char*   gdrv_fmt_typename(char* dst,char* prefix,int ucase,char* src);


extern gdrv_mesg_t* gdrv_mesg_new(gint size);
extern void      gdrv_mesg_free(gdrv_mesg_t* mesg);
extern gdrv_mesg_t* gdrv_mesg_realloc(gdrv_mesg_t* mesg, gint newsize);
extern gdrv_mesg_t* gdrv_mesg_recv(GIOChannel* source, GIOError* err);
extern int       gdrv_mesg_send(GIOChannel* dest, gdrv_mesg_t*, GIOError* err);

extern int gdrv_encode_version(gdrv_mesg_t** mesg);
extern int gdrv_encode_tuple_header(gdrv_mesg_t** mesg, int x);
extern int gdrv_encode_list_header(gdrv_mesg_t** mesg, int x);
extern int gdrv_encode_empty_list(gdrv_mesg_t** mesg);
extern int gdrv_encode_atom(gdrv_mesg_t** mesg, char* x);
extern int gdrv_encode_char(gdrv_mesg_t** mesg, char x);
extern int gdrv_encode_ushort(gdrv_mesg_t** mesg, unsigned short x);
extern int gdrv_encode_short(gdrv_mesg_t** mesg, short x);
extern int gdrv_encode_uint(gdrv_mesg_t** mesg, unsigned int x);
extern int gdrv_encode_int(gdrv_mesg_t** mesg, int x);
extern int gdrv_encode_ulong(gdrv_mesg_t** mesg, unsigned long x);
extern int gdrv_encode_long(gdrv_mesg_t** mesg, long x);
extern int gdrv_encode_float(gdrv_mesg_t** mesg, float x);
extern int gdrv_encode_double(gdrv_mesg_t** mesg, double x);
extern int gdrv_encode_term(gdrv_mesg_t** mesg, ETERM* x);
extern int gdrv_encode_string(gdrv_mesg_t** mesg, char* x);
extern int gdrv_encode_boolean(gdrv_mesg_t** mesg, int x);
extern int gdrv_encode_binary(gdrv_mesg_t** mesg, char* x, int len);
/* high-level */
extern int gdrv_encode_pointer(gdrv_mesg_t** mesg, gpointer ptr, GtkType type);
extern int gdrv_encode_boxed(gdrv_mesg_t** mesg, gpointer ptr, GtkType type);
extern int gdrv_encode_object(gdrv_mesg_t** mesg, GtkObject* obj);

extern int gdrv_decode_type(gdrv_mesg_t* mp, int* type, int* len);
extern int gdrv_decode_version(gdrv_mesg_t* mesg, int* vers);
extern int gdrv_decode_tuple_header(gdrv_mesg_t* mesg, int* x);
extern int gdrv_decode_list_header(gdrv_mesg_t* mesg, int* x);
extern int gdrv_decode_empty_list(gdrv_mesg_t* mesg);
extern int gdrv_decode_atom(gdrv_mesg_t* mesg, char* x, int max_len);
extern int gdrv_decode_char(gdrv_mesg_t* mesg, char* x);
extern int gdrv_decode_short(gdrv_mesg_t* mesg, short* x);
extern int gdrv_decode_ushort(gdrv_mesg_t* mesg, unsigned short* x);
extern int gdrv_decode_int(gdrv_mesg_t* mesg, int* x);
extern int gdrv_decode_uint(gdrv_mesg_t* mesg, unsigned int* x);
extern int gdrv_decode_ulong(gdrv_mesg_t* mesg, unsigned long* x);
extern int gdrv_decode_long(gdrv_mesg_t* mesg, long* x);
extern int gdrv_decode_float(gdrv_mesg_t* mesg, float* x);
extern int gdrv_decode_double(gdrv_mesg_t* mesg, double* x);
extern int gdrv_decode_term(gdrv_mesg_t* mesg, ETERM** x);
extern int gdrv_decode_strn(gdrv_mesg_t* mesg, char* x, int max_len);
extern int gdrv_decode_boolean(gdrv_mesg_t* mesg, int* x);
extern int gdrv_decode_binary(gdrv_mesg_t* mesg, void* x, long* len);
/* high-level */
extern int gdrv_decode_string(gdrv_mesg_t* mesg, char** x);
extern int gdrv_decode_pointer(gdrv_mesg_t* mesg, gpointer* ptr, GtkType type);
extern int gdrv_decode_boxed(gdrv_mesg_t* mesg, gpointer* ptr, GtkType type);
extern int gdrv_decode_object(gdrv_mesg_t* mesg, GtkObject** obj);
extern int gdrv_decode_arg(gdrv_mesg_t* mesg, GtkArg* arg);

#if GTK_VERSION > GTK_VERS(2,0,0)
#define IS_ARRAY(type) (g_type_parent(type) == GTK_TYPE_ARRAY)
#else
#define IS_ARRAY(type) \
  ((GTK_FUNDAMENTAL_TYPE(type) == GTK_TYPE_POINTER) && \
   (GTK_TYPE_SEQNO(type) >= GTK_TYPE_SEQNO(GTK_TYPE_ARRAY_OF_VOID)) && \
   (GTK_TYPE_SEQNO(type) <= GTK_TYPE_SEQNO(GTK_TYPE_ARRAY_OF_ARG)))
#endif

extern GtkType array_element_type(GtkType array_type);

/* def2mod external types */
extern char* def2mod_module_global(void);
extern char* def2mod_type_include(void);
extern char* def2mod_module_init(void);
extern void def2mod_type_init(void);

extern void gdrv_type_load(e_type_info_t* info);

extern void erl_term_free (void*);

extern void gdrv_init_type(GtkType type);

extern gint gdrv_function_export(const char* mod_name,
				 const char* fun_name,
				 FFunction c_function,
				 FMarshaller marshaller,
				 GtkType return_type,
				 guint arity, ...);

extern gint gdrv_function_unexport(const char* mod_name,
				   const char* fun_name);

extern gint gdrv_function_exportv(const char* mod_name,
				  const char* fun_name,
				  FFunction function,
				  FMarshaller marshaller,
				  GtkType return_type,
				  guint arity,
				  e_arg_t* arg_type);

extern gint gdrv_struct_export(const char* mod_name,
			       const char* struct_name,
			       GtkType     type,
			       gboolean    private,
			       size_t      size,
			       int         arity,
			       FCoder      encode,
			       FCoder      decode);

extern gint gdrv_struct_unexport(const char* mod_name,
				 const char* struct_name);
			       
extern void gtk_x_version(guint* major, guint* minor, guint* micro);

extern GtkSignalFunc gtk_x_object_event_method(GtkObject*, gchar*);
extern void gtk_x_object_set_user_data(GtkObject* object, ETERM*);
extern ETERM* gtk_x_object_get_user_data(GtkObject* object);
extern void gtk_x_object_set_data(GtkObject* object, char* key, ETERM*);
extern ETERM* gtk_x_object_get_data(GtkObject* object, char* key);
extern ETERM* gtk_x_container_children(GtkContainer* container);

extern void gtk_widget_set_flags(GtkWidget* widget, guint flags);
extern void gtk_widget_unset_flags(GtkWidget* widget, guint flags);
extern guint gtk_widget_get_flags(GtkWidget* widget);
extern guint gtk_widget_get_state(GtkWidget* widget);
extern guint gtk_widget_get_saved_state(GtkWidget* widget);
extern GtkWidgetAuxInfo* gtk_widget_get_aux_info(GtkWidget* widget);

extern void gtk_object_set_flags(GtkObject* object, guint flags);
extern void gtk_object_unset_flags(GtkObject* object, guint flags);
extern guint gtk_object_get_flags(GtkObject* object);

#endif



