/*
** Built on and extra types
*/
#include <stdio.h>
#include <ctype.h>

#include <gtk/gtk.h>

#include "gtk_drv_api.h"

/* c-types */
GtkType GTK_TYPE_CVOID   = 0;
GtkType GTK_TYPE_CCHAR   = 0;
GtkType GTK_TYPE_CINT    = 0;
GtkType GTK_TYPE_CSHORT  = 0;
GtkType GTK_TYPE_CLONG   = 0;
GtkType GTK_TYPE_CFLOAT  = 0;
GtkType GTK_TYPE_CDOUBLE = 0;

/* glib-types */
#if GTK_VERSION < GTK_VERS(2,0,0)
GtkType GTK_TYPE_GCHAR   = 0;
#endif
GtkType GTK_TYPE_GUINT8  = 0;
GtkType GTK_TYPE_GUINT16 = 0;
GtkType GTK_TYPE_GUSHORT = 0;
GtkType GTK_TYPE_GUINT32 = 0;
GtkType GTK_TYPE_GULONG  = 0;

GtkType GTK_TYPE_GINT8   = 0;
GtkType GTK_TYPE_GINT16  = 0;
GtkType GTK_TYPE_GINT32  = 0;
GtkType GTK_TYPE_GSTRING = 0;

GtkType GTK_TYPE_UNICHAR = 0;
GtkType GTK_TYPE_UNICHAR2 = 0;

/* Adding some GDK types */
GtkType GDK_TYPE_BITMAP    = 0;

#if GTK_VERSION < GTK_VERS(2,0,0)
GtkType GDK_TYPE_IMAGE       = 0;
GtkType GDK_TYPE_PIXMAP      = 0;
GtkType GDK_TYPE_DRAWABLE    = 0;
GtkType GDK_TYPE_GC          = 0;
GtkType GDK_TYPE_RECTANGLE   = 0;
GtkType GDK_TYPE_CURSOR      = 0;
GtkType GTK_TYPE_REQUISITION = 0;
GtkType GTK_TYPE_RC_STYLE    = 0;
#endif

GtkType GDK_TYPE_ATOM        = 0;
GtkType GDK_TYPE_POINT       = 0;
GtkType GDK_TYPE_SEGMENT     = 0;
GtkType GDK_TYPE_WINDOW_ATTR = 0;
GtkType GDK_TYPE_GEOMETRY    = 0;

GtkType GTK_TYPE_WIDGET_AUX_INFO = 0;
GtkType GTK_TYPE_ALLOCATION = 0;
GtkType GTK_TYPE_ETERM       = 0;
GtkType GTK_TYPE_ARRAY       = 0;
GtkType GTK_TYPE_GLIST       = 0;
GtkType GTK_TYPE_GSLIST      = 0;
GtkType GTK_TYPE_ARG         = 0;
GtkType GTK_TYPE_TYPE        = 0;

/* gtk_drv types */
GtkType GTK_TYPE_ARRAY_OF_VOID    = 0;
GtkType GTK_TYPE_ARRAY_OF_CHAR    = 0;
GtkType GTK_TYPE_ARRAY_OF_UCHAR   = 0;
GtkType GTK_TYPE_ARRAY_OF_BOOL    = 0;
GtkType GTK_TYPE_ARRAY_OF_INT     = 0;
GtkType GTK_TYPE_ARRAY_OF_UINT    = 0;
GtkType GTK_TYPE_ARRAY_OF_LONG    = 0;
GtkType GTK_TYPE_ARRAY_OF_ULONG   = 0;
GtkType GTK_TYPE_ARRAY_OF_FLOAT   = 0;
GtkType GTK_TYPE_ARRAY_OF_DOUBLE  = 0;
GtkType GTK_TYPE_ARRAY_OF_STRING  = 0;
GtkType GTK_TYPE_ARRAY_OF_ENUM    = 0;
GtkType GTK_TYPE_ARRAY_OF_FLAGS   = 0;
GtkType GTK_TYPE_ARRAY_OF_BOXED   = 0;
GtkType GTK_TYPE_ARRAY_OF_POINTER = 0;
GtkType GTK_TYPE_ARRAY_OF_OBJECT  = 0;
GtkType GDK_TYPE_ARRAY_OF_POINT   = 0;
GtkType GDK_TYPE_ARRAY_OF_SEGMENT = 0;
GtkType GTK_TYPE_ARRAY_OF_ARG     = 0;

#if GTK_VERSION >= GTK_VERS(2,0,0)
GtkType gtk_TYPE_TEXT_ITER = 0;
GtkType gtk_TYPE_TEXT_ATTRIBUTES = 0;
GtkType G_TYPE_QUARK = 0;

#endif


static e_type_info_t type_info[] = {
    /* install the C-types */
    { "void",         &GTK_TYPE_CVOID,    GTK_TYPE_NONE,     NULL },
    { "char",         &GTK_TYPE_CCHAR,    GTK_TYPE_CHAR,     NULL },
    { "int",          &GTK_TYPE_CINT,     GTK_TYPE_INT,      NULL },
    /* fixme: add a GTK_TYPE_SHORT */
    { "short",        &GTK_TYPE_CSHORT,   GTK_TYPE_INT,      NULL },
    { "long",         &GTK_TYPE_CLONG,    GTK_TYPE_LONG,     NULL },
    { "float",        &GTK_TYPE_CFLOAT,   GTK_TYPE_FLOAT,    NULL },
    { "double",       &GTK_TYPE_CDOUBLE,  GTK_TYPE_DOUBLE,   NULL },
    
    /* Install glib types */
    { "guint8",       &GTK_TYPE_GUINT8,   GTK_TYPE_UCHAR,    NULL },
    /* fixme: add a GTK_TYPE_SHORT */
    { "guint16",      &GTK_TYPE_GUINT16,  GTK_TYPE_UINT,     NULL },
    { "gushort",      &GTK_TYPE_GUSHORT,  GTK_TYPE_UINT,     NULL },
    { "guint32",      &GTK_TYPE_GUINT32,  GTK_TYPE_ULONG,    NULL },
    { "gulong",       &GTK_TYPE_GULONG,   GTK_TYPE_ULONG,    NULL },
    { "gint8",        &GTK_TYPE_GINT8,    GTK_TYPE_CHAR,     NULL },
    /* fixme: add a GTK_TYPE_SHORT */
    { "gint16",       &GTK_TYPE_GINT16,   GTK_TYPE_INT,      NULL },
    { "gint32",       &GTK_TYPE_GINT32,   GTK_TYPE_LONG,     NULL },
    { "gstring",      &GTK_TYPE_GSTRING,  GTK_TYPE_STRING,   NULL },
    /* Unicode char Gtk2.0 (gunichar2 should be a 16 bit) */
    { "gunichar",     &GTK_TYPE_UNICHAR,  GTK_TYPE_ULONG,    NULL },
    { "gunichar2",    &GTK_TYPE_UNICHAR2, GTK_TYPE_UINT,     NULL },

    /* other "missing" types */
    { "ETERM",        &GTK_TYPE_ETERM,     GTK_TYPE_POINTER, NULL },
    { "GList",        &GTK_TYPE_GLIST,     GTK_TYPE_POINTER, NULL },
    { "GSList",       &GTK_TYPE_GSLIST,    GTK_TYPE_POINTER, NULL },
    { "GtkArray",     &GTK_TYPE_ARRAY,     0,                NULL },
    { "GdkPoint",     &GDK_TYPE_POINT,     GTK_TYPE_BOXED,   NULL },
    { "GdkSegment",   &GDK_TYPE_SEGMENT,   GTK_TYPE_BOXED,   NULL },
    { "GdkWindowAttr",&GDK_TYPE_WINDOW_ATTR, GTK_TYPE_BOXED, NULL },
    { "GdkGeometry",  &GDK_TYPE_GEOMETRY,  GTK_TYPE_BOXED, NULL },
    { "GtkArg",       &GTK_TYPE_ARG,       GTK_TYPE_POINTER, NULL },
    { "GtkType",      &GTK_TYPE_TYPE,      GTK_TYPE_LONG,    NULL },
    { "GdkAtom",      &GDK_TYPE_ATOM,	   GTK_TYPE_ULONG,   NULL },
    { "GtkWidgetAuxInfo", &GTK_TYPE_WIDGET_AUX_INFO,  GTK_TYPE_BOXED, NULL },
    { "GtkAllocation",    &GTK_TYPE_ALLOCATION,       GTK_TYPE_BOXED, NULL },

#if GTK_VERSION < GTK_VERS(2,0,0)
    { "gchar",          &GTK_TYPE_GCHAR,    GTK_TYPE_CHAR,     NULL },
    { "GdkCursor",      &GDK_TYPE_CURSOR,    GTK_TYPE_BOXED,   NULL },
    { "GdkRectangle",   &GDK_TYPE_RECTANGLE, GTK_TYPE_BOXED,   NULL },
    { "GdkImage",       &GDK_TYPE_IMAGE,     GTK_TYPE_BOXED,   NULL },
    { "GdkGC",          &GDK_TYPE_GC,          GTK_TYPE_BOXED,   NULL },
    { "GdkDrawable",    &GDK_TYPE_DRAWABLE,    GTK_TYPE_BOXED,   NULL },
    { "GdkBitmap",      &GDK_TYPE_BITMAP,      GTK_TYPE_BOXED,   NULL },
    { "GdkPixmap",      &GDK_TYPE_PIXMAP,      GTK_TYPE_BOXED,   NULL },
    { "GtkRcStyle",     &GTK_TYPE_RC_STYLE,    GTK_TYPE_BOXED,   NULL },
    { "GtkRequisition", &GTK_TYPE_REQUISITION, GTK_TYPE_BOXED, NULL },
#else
    /* Ugly hack :-( */
    { "GtkTextIter",        &gtk_TYPE_TEXT_ITER, GTK_TYPE_POINTER, NULL },
    { "GtkTextAttributes",  &gtk_TYPE_TEXT_ATTRIBUTES, GTK_TYPE_POINTER,NULL },
    { "GQuark",             &G_TYPE_QUARK,       GTK_TYPE_ULONG, NULL },

#endif

    /* special array type */
    { "void_array_t",       &GTK_TYPE_ARRAY_OF_VOID,   0, NULL },
    { "gchar_array_t",      &GTK_TYPE_ARRAY_OF_CHAR,   0, NULL },
    { "guchar_array_t",     &GTK_TYPE_ARRAY_OF_UCHAR,  0, NULL },
    { "gboolean_array_t",   &GTK_TYPE_ARRAY_OF_BOOL,   0, NULL },
    { "gint_array_t",       &GTK_TYPE_ARRAY_OF_INT,    0, NULL },
    { "guint_array_t",      &GTK_TYPE_ARRAY_OF_UINT,   0, NULL },
    { "glong_array_t",      &GTK_TYPE_ARRAY_OF_LONG,   0, NULL },
    { "gulong_array_t",     &GTK_TYPE_ARRAY_OF_ULONG,  0, NULL },
    { "gfloat_array_t",     &GTK_TYPE_ARRAY_OF_FLOAT,  0, NULL },
    { "gdouble_array_t",    &GTK_TYPE_ARRAY_OF_DOUBLE, 0, NULL },
    { "gstring_array_t",    &GTK_TYPE_ARRAY_OF_STRING, 0, NULL },
    { "GtkEnum_array_t",    &GTK_TYPE_ARRAY_OF_ENUM,   0, NULL },
    { "GtkFlags_array_t",   &GTK_TYPE_ARRAY_OF_FLAGS,  0, NULL },
    { "GtkBoxed_array_t",   &GTK_TYPE_ARRAY_OF_BOXED,  0, NULL },
    { "gpointer_array_t",   &GTK_TYPE_ARRAY_OF_POINTER,0, NULL },
    { "GtkObject_array_t",  &GTK_TYPE_ARRAY_OF_OBJECT, 0, NULL },
    { "GdkPoint_array_t",   &GDK_TYPE_ARRAY_OF_POINT,  0, NULL },
    { "GdkSegment_array_t", &GDK_TYPE_ARRAY_OF_SEGMENT,0, NULL },
    { "GtkArg_array_t",     &GTK_TYPE_ARRAY_OF_ARG,    0, NULL },
    { NULL }
};



#if GTK_VERSION >= GTK_VERS(2,0,0)
GtkType gdrv_register_type(e_type_info_t* et)
{
    GTypeFlags flags = 0;
    GTypeInfo tinfo = {0, };

    if (et->parent == 0) {
	int n = strlen(et->type_name);
	int a = strlen("array_t");
	
	if ((n > a) && (strcmp(et->type_name+(n-a), "array_t") == 0)) {
	    et->parent = GTK_TYPE_ARRAY;
	}
	else {
	    GTypeFundamentalInfo finfo = {0,};
	    et->parent = GTK_TYPE_POINTER;
	    if (strcmp(et->type_name, "GtkArray") == 0) {
		GtkType ft = g_type_fundamental_next();

		ft = G_TYPE_MAKE_FUNDAMENTAL(ft);
		finfo.type_flags = G_TYPE_FLAG_DERIVABLE;
		return g_type_register_fundamental(ft,
						   et->type_name, 
						   &tinfo,
						   &finfo,
						   0);
	    }
	}
    }
    else if (et->parent == GTK_TYPE_ENUM) 
	return g_enum_register_static(et->type_name, et->values);
    return g_type_register_static(et->parent, 
				  et->type_name, 
				  &tinfo, flags);
}
#else
GtkType gdrv_register_type(e_type_info_t* et)
{
    GtkTypeInfo info;

    info.type_name = et->type_name;
    info.object_size = 0;
    info.class_size = 0;
    info.class_init_func = NULL;
    info.object_init_func = NULL;
    info.reserved_1 = (gpointer) et->values;
    info.reserved_2 = NULL;
    if (et->parent == 0)
	et->parent = GTK_TYPE_POINTER;
    return gtk_type_unique(et->parent, &info);
}
#endif

void gdrv_type_load(e_type_info_t* tab)
{
    int i;

    for (i = 0; tab[i].type_name != NULL; i++) {
	GtkType t;
	if ((t = gtk_type_from_name(tab[i].type_name)) == 0)
	    t = gdrv_register_type(&tab[i]);
	(*tab[i].type_id) = t;
    }
}

/* generated by:
**
**
**    grep '#define GTK_TYPE[_A-Z]*[[:blank:]]' /usr/include/gtk/ *.h |
**       awk '{ print "    gtk_type_class("$2");" }' 
**
*/

void gtk_drv_type_init()
{
#if GTK_VERSION >= GTK_VERS(2,0,0)
    g_type_init();

    /* GDK builins */
    INIT_TYPE(GDK_TYPE_CURSOR_TYPE);
    INIT_TYPE(GDK_TYPE_DRAG_ACTION);
    INIT_TYPE(GDK_TYPE_DRAG_PROTOCOL);
    INIT_TYPE(GDK_TYPE_FILTER_RETURN);
    INIT_TYPE(GDK_TYPE_EVENT_TYPE);
    INIT_TYPE(GDK_TYPE_EVENT_MASK);
    INIT_TYPE(GDK_TYPE_VISIBILITY_STATE);
    INIT_TYPE(GDK_TYPE_SCROLL_DIRECTION);
    INIT_TYPE(GDK_TYPE_NOTIFY_TYPE);
    INIT_TYPE(GDK_TYPE_CROSSING_MODE);
    INIT_TYPE(GDK_TYPE_PROPERTY_STATE);
    INIT_TYPE(GDK_TYPE_WINDOW_STATE);
    INIT_TYPE(GDK_TYPE_SETTING_ACTION);
    INIT_TYPE(GDK_TYPE_FONT_TYPE);
    INIT_TYPE(GDK_TYPE_CAP_STYLE);
    INIT_TYPE(GDK_TYPE_FILL);
    INIT_TYPE(GDK_TYPE_FUNCTION);
    INIT_TYPE(GDK_TYPE_JOIN_STYLE);
    INIT_TYPE(GDK_TYPE_LINE_STYLE);
    INIT_TYPE(GDK_TYPE_SUBWINDOW_MODE);
    INIT_TYPE(GDK_TYPE_GC_VALUES_MASK);
    INIT_TYPE(GDK_TYPE_IMAGE_TYPE);
    INIT_TYPE(GDK_TYPE_EXTENSION_MODE);
    INIT_TYPE(GDK_TYPE_INPUT_SOURCE);
    INIT_TYPE(GDK_TYPE_INPUT_MODE);
    INIT_TYPE(GDK_TYPE_AXIS_USE);
    INIT_TYPE(GDK_TYPE_PROP_MODE);
    INIT_TYPE(GDK_TYPE_FILL_RULE);
    INIT_TYPE(GDK_TYPE_OVERLAP_TYPE);
    INIT_TYPE(GDK_TYPE_RGB_DITHER);
    INIT_TYPE(GDK_TYPE_BYTE_ORDER);
    INIT_TYPE(GDK_TYPE_MODIFIER_TYPE);
    INIT_TYPE(GDK_TYPE_INPUT_CONDITION);
    INIT_TYPE(GDK_TYPE_STATUS);
    INIT_TYPE(GDK_TYPE_GRAB_STATUS);
    INIT_TYPE(GDK_TYPE_VISUAL_TYPE);
    INIT_TYPE(GDK_TYPE_WINDOW_CLASS);
    INIT_TYPE(GDK_TYPE_WINDOW_TYPE);
    INIT_TYPE(GDK_TYPE_WINDOW_ATTRIBUTES_TYPE);
    INIT_TYPE(GDK_TYPE_WINDOW_HINTS);
    INIT_TYPE(GDK_TYPE_WINDOW_TYPE_HINT);
    INIT_TYPE(GDK_TYPE_WM_DECORATION);
    INIT_TYPE(GDK_TYPE_WM_FUNCTION);
    INIT_TYPE(GDK_TYPE_GRAVITY);
    INIT_TYPE(GDK_TYPE_WINDOW_EDGE);

    INIT_TYPE(GDK_TYPE_COLOR);
    INIT_TYPE(GDK_TYPE_FONT);
    INIT_TYPE(GDK_TYPE_RECTANGLE);
    INIT_TYPE(GDK_TYPE_CURSOR);
    INIT_TYPE(GDK_TYPE_DRAG_CONTEXT);
    INIT_TYPE(GDK_TYPE_EVENT);
    INIT_TYPE(GDK_TYPE_IMAGE);
    /* Gtk builtins */

    INIT_TYPE(GTK_TYPE_ACCEL_FLAGS);
    INIT_TYPE(GTK_TYPE_CALENDAR_DISPLAY_OPTIONS);
    INIT_TYPE(GTK_TYPE_CELL_TYPE);
    INIT_TYPE(GTK_TYPE_CLIST_DRAG_POS);
    INIT_TYPE(GTK_TYPE_BUTTON_ACTION);
    INIT_TYPE(GTK_TYPE_CTREE_POS);
    INIT_TYPE(GTK_TYPE_CTREE_LINE_STYLE);
    INIT_TYPE(GTK_TYPE_CTREE_EXPANDER_STYLE);
    INIT_TYPE(GTK_TYPE_CTREE_EXPANSION_TYPE);
    INIT_TYPE(GTK_TYPE_CELL_RENDERER_STATE);
    INIT_TYPE(GTK_TYPE_CELL_RENDERER_MODE);
    INIT_TYPE(GTK_TYPE_DEBUG_FLAG);
    INIT_TYPE(GTK_TYPE_DIALOG_FLAGS);
    INIT_TYPE(GTK_TYPE_RESPONSE_TYPE);
    INIT_TYPE(GTK_TYPE_DEST_DEFAULTS);
    INIT_TYPE(GTK_TYPE_TARGET_FLAGS);
    INIT_TYPE(GTK_TYPE_ANCHOR_TYPE);
    INIT_TYPE(GTK_TYPE_ARROW_TYPE);
    INIT_TYPE(GTK_TYPE_ATTACH_OPTIONS);
    INIT_TYPE(GTK_TYPE_BUTTON_BOX_STYLE);
    INIT_TYPE(GTK_TYPE_CURVE_TYPE);
    INIT_TYPE(GTK_TYPE_DELETE_TYPE);
    INIT_TYPE(GTK_TYPE_DIRECTION_TYPE);
    INIT_TYPE(GTK_TYPE_EXPANDER_STYLE);
    INIT_TYPE(GTK_TYPE_ICON_SIZE);
    INIT_TYPE(GTK_TYPE_SIDE_TYPE);
    INIT_TYPE(GTK_TYPE_TEXT_DIRECTION);
    INIT_TYPE(GTK_TYPE_JUSTIFICATION);
    INIT_TYPE(GTK_TYPE_MATCH_TYPE);
    INIT_TYPE(GTK_TYPE_MENU_DIRECTION_TYPE);
    INIT_TYPE(GTK_TYPE_METRIC_TYPE);
    INIT_TYPE(GTK_TYPE_MOVEMENT_STEP);
    INIT_TYPE(GTK_TYPE_ORIENTATION);
    INIT_TYPE(GTK_TYPE_CORNER_TYPE);
    INIT_TYPE(GTK_TYPE_PACK_TYPE);
    INIT_TYPE(GTK_TYPE_PATH_PRIORITY_TYPE);
    INIT_TYPE(GTK_TYPE_PATH_TYPE);
    INIT_TYPE(GTK_TYPE_POLICY_TYPE);
    INIT_TYPE(GTK_TYPE_POSITION_TYPE);
    INIT_TYPE(GTK_TYPE_PREVIEW_TYPE);
    INIT_TYPE(GTK_TYPE_RELIEF_STYLE);
    INIT_TYPE(GTK_TYPE_RESIZE_MODE);
    INIT_TYPE(GTK_TYPE_SIGNAL_RUN_TYPE);
    INIT_TYPE(GTK_TYPE_SCROLL_TYPE);
    INIT_TYPE(GTK_TYPE_SELECTION_MODE);
    INIT_TYPE(GTK_TYPE_SHADOW_TYPE);
    INIT_TYPE(GTK_TYPE_STATE_TYPE);
    INIT_TYPE(GTK_TYPE_SUBMENU_DIRECTION);
    INIT_TYPE(GTK_TYPE_SUBMENU_PLACEMENT);
    INIT_TYPE(GTK_TYPE_TOOLBAR_STYLE);
    INIT_TYPE(GTK_TYPE_UPDATE_TYPE);
    INIT_TYPE(GTK_TYPE_VISIBILITY);
    INIT_TYPE(GTK_TYPE_WINDOW_POSITION);
    INIT_TYPE(GTK_TYPE_WINDOW_TYPE);
    INIT_TYPE(GTK_TYPE_WRAP_MODE);
    INIT_TYPE(GTK_TYPE_SORT_TYPE);
    INIT_TYPE(GTK_TYPE_IMAGE_TYPE);
    INIT_TYPE(GTK_TYPE_MESSAGE_TYPE);
    INIT_TYPE(GTK_TYPE_BUTTONS_TYPE);
    INIT_TYPE(GTK_TYPE_NOTEBOOK_TAB);
    INIT_TYPE(GTK_TYPE_OBJECT_FLAGS);
    INIT_TYPE(GTK_TYPE_ARG_FLAGS);
    INIT_TYPE(GTK_TYPE_PRIVATE_FLAGS);
    INIT_TYPE(GTK_TYPE_PROGRESS_BAR_STYLE);
    INIT_TYPE(GTK_TYPE_PROGRESS_BAR_ORIENTATION);
    INIT_TYPE(GTK_TYPE_RC_FLAGS);
    INIT_TYPE(GTK_TYPE_RC_TOKEN_TYPE);
    INIT_TYPE(GTK_TYPE_SIZE_GROUP_MODE);
    INIT_TYPE(GTK_TYPE_SPIN_BUTTON_UPDATE_POLICY);
    INIT_TYPE(GTK_TYPE_SPIN_TYPE);
    INIT_TYPE(GTK_TYPE_TEXT_SEARCH_FLAGS);
    INIT_TYPE(GTK_TYPE_TEXT_WINDOW_TYPE);
    INIT_TYPE(GTK_TYPE_TOOLBAR_CHILD_TYPE);
    INIT_TYPE(GTK_TYPE_TOOLBAR_SPACE_STYLE);
    INIT_TYPE(GTK_TYPE_TREE_VIEW_MODE);
    INIT_TYPE(GTK_TYPE_TREE_MODEL_FLAGS);
    INIT_TYPE(GTK_TYPE_TREE_VIEW_DROP_POSITION);
    INIT_TYPE(GTK_TYPE_TREE_VIEW_COLUMN_SIZING);
    INIT_TYPE(GTK_TYPE_WIDGET_FLAGS);
    INIT_TYPE(GTK_TYPE_WIDGET_HELP_TYPE);

#endif
    INIT_TYPE(GTK_TYPE_WIDGET);
    INIT_TYPE(GTK_TYPE_WINDOW);
    INIT_TYPE(GTK_TYPE_ACCEL_LABEL);
    INIT_TYPE(GTK_TYPE_ADJUSTMENT);
    INIT_TYPE(GTK_TYPE_ALIGNMENT);
    INIT_TYPE(GTK_TYPE_ARROW);
    INIT_TYPE(GTK_TYPE_CONTAINER);
    INIT_TYPE(GTK_TYPE_BIN);
    INIT_TYPE(GTK_TYPE_FRAME);
    INIT_TYPE(GTK_TYPE_BOX);
    INIT_TYPE(GTK_TYPE_BUTTON);
    INIT_TYPE(GTK_TYPE_CALENDAR);
    INIT_TYPE(GTK_TYPE_CHECK_BUTTON);
    INIT_TYPE(GTK_TYPE_CHECK_MENU_ITEM);
    INIT_TYPE(GTK_TYPE_CLIST);
    INIT_TYPE(GTK_TYPE_COLOR_SELECTION);
    INIT_TYPE(GTK_TYPE_COLOR_SELECTION_DIALOG);
    INIT_TYPE(GTK_TYPE_CTREE);
    INIT_TYPE(GTK_TYPE_CURVE);
    INIT_TYPE(GTK_TYPE_DIALOG);
    INIT_TYPE(GTK_TYPE_DRAWING_AREA);
    INIT_TYPE(GTK_TYPE_EDITABLE);
    INIT_TYPE(GTK_TYPE_ENTRY);
    INIT_TYPE(GTK_TYPE_EVENT_BOX);
    INIT_TYPE(GTK_TYPE_FILE_SELECTION);
    INIT_TYPE(GTK_TYPE_FIXED);
    INIT_TYPE(GTK_TYPE_FONT_SELECTION);
    INIT_TYPE(GTK_TYPE_FONT_SELECTION_DIALOG);
    INIT_TYPE(GTK_TYPE_HANDLE_BOX);
    INIT_TYPE(GTK_TYPE_HBOX);
    INIT_TYPE(GTK_TYPE_HSCALE);
    INIT_TYPE(GTK_TYPE_HSCROLLBAR);
    INIT_TYPE(GTK_TYPE_HSEPARATOR);
    INIT_TYPE(GTK_TYPE_IMAGE);
    INIT_TYPE(GTK_TYPE_INPUT_DIALOG);
    INIT_TYPE(GTK_TYPE_ITEM);
    INIT_TYPE(GTK_TYPE_LABEL);
    INIT_TYPE(GTK_TYPE_LAYOUT);
    INIT_TYPE(GTK_TYPE_LIST);
    INIT_TYPE(GTK_TYPE_LIST_ITEM);
    INIT_TYPE(GTK_TYPE_MENU);
    INIT_TYPE(GTK_TYPE_MENU_BAR);
    INIT_TYPE(GTK_TYPE_MISC);
    INIT_TYPE(GTK_TYPE_NOTEBOOK);
    INIT_TYPE(GTK_TYPE_OPTION_MENU);
    INIT_TYPE(GTK_TYPE_PANED);
    INIT_TYPE(GTK_TYPE_PIXMAP);
    INIT_TYPE(GTK_TYPE_PREVIEW);
    INIT_TYPE(GTK_TYPE_PROGRESS);
    INIT_TYPE(GTK_TYPE_PROGRESS_BAR);
    INIT_TYPE(GTK_TYPE_RADIO_BUTTON);
    INIT_TYPE(GTK_TYPE_RADIO_MENU_ITEM);
    INIT_TYPE(GTK_TYPE_RANGE);
    INIT_TYPE(GTK_TYPE_RULER);
    INIT_TYPE(GTK_TYPE_SCALE);
    INIT_TYPE(GTK_TYPE_SCROLLBAR);
    INIT_TYPE(GTK_TYPE_SCROLLED_WINDOW);
    INIT_TYPE(GTK_TYPE_SEPARATOR);
    INIT_TYPE(GTK_TYPE_SPIN_BUTTON);
    INIT_TYPE(GTK_TYPE_TABLE);
    INIT_TYPE(GTK_TYPE_TEAROFF_MENU_ITEM);
    INIT_TYPE(GTK_TYPE_TOGGLE_BUTTON);
    INIT_TYPE(GTK_TYPE_TOOLBAR);
    INIT_TYPE(GTK_TYPE_TOOLTIPS);
    INIT_TYPE(GTK_TYPE_VBOX);
    INIT_TYPE(GTK_TYPE_VIEWPORT);
    INIT_TYPE(GTK_TYPE_VSCALE);
    INIT_TYPE(GTK_TYPE_VSCROLLBAR);
    INIT_TYPE(GTK_TYPE_VSEPARATOR);

    /* MISSING GTK_TYPE_ */
    INIT_TYPE(GTK_TYPE_HRULER);
    INIT_TYPE(GTK_TYPE_VRULER);
    INIT_TYPE(GTK_TYPE_STATUSBAR);
    INIT_TYPE(GTK_TYPE_VBUTTON_BOX);
    INIT_TYPE(GTK_TYPE_HBUTTON_BOX);
    INIT_TYPE(GTK_TYPE_INVISIBLE);
    INIT_TYPE(GTK_TYPE_HPANED);
    INIT_TYPE(GTK_TYPE_VPANED);
    INIT_TYPE(GTK_TYPE_PLUG);
    INIT_TYPE(GTK_TYPE_COMBO);
#ifndef __WIN32__
    INIT_TYPE(GTK_TYPE_SOCKET);
#endif

    INIT_TYPE(GTK_TYPE_ASPECT_FRAME);

#if GTK_VERSION < GTK_VERS(2,0,0)
    INIT_TYPE(GTK_TYPE_TEXT);
    INIT_TYPE(GTK_TYPE_DATA);
    INIT_TYPE(GTK_TYPE_PACKER);
    INIT_TYPE(GTK_TYPE_TREE);
    INIT_TYPE(GTK_TYPE_TREE_ITEM);
#endif

#if GTK_VERSION >= GTK_VERS(2,0,0)
    INIT_TYPE(GTK_TYPE_RC_STYLE);
    INIT_TYPE(GTK_TYPE_STYLE);
    INIT_TYPE(GTK_TYPE_ACCEL_GROUP);
    INIT_TYPE(GTK_TYPE_TEXT_BUFFER);
    INIT_TYPE(GTK_TYPE_TEXT_VIEW);
    INIT_TYPE(GTK_TYPE_TEXT_ITER);
    INIT_TYPE(GTK_TYPE_TEXT_MARK);
    INIT_TYPE(GTK_TYPE_TEXT_TAG);
    INIT_TYPE(GTK_TYPE_TEXT_CHILD_ANCHOR);
    INIT_TYPE(GTK_TYPE_TEXT_TAG_TABLE);
    INIT_TYPE(GTK_TYPE_TEXT_ATTRIBUTES);

    /* and new gdk types */
    INIT_TYPE(GDK_TYPE_DRAWABLE);
    INIT_TYPE(GDK_TYPE_PIXMAP);
    INIT_TYPE(GDK_TYPE_PIXBUF);
    INIT_TYPE(GDK_TYPE_GC);
    GDK_TYPE_BITMAP    = GDK_TYPE_DRAWABLE;
#endif
    gdrv_type_load(type_info);
}


/*
** Format a type name on form AaaBbbCcc => Aaa_Bbb_Ccc
** special case: AaaBBbbCcc             => Aaa_BBb_Ccc
**               AaaBBCcc               => Aaa_BB_Ccc
** 
** 1) remove "prefix" i.e Aaa if match
** 2) the rest is formated as BBB_CCC when ucase = 1
**    or bbb_ccc when ucase = 0
** 3) the dst is return from the op
*/
char* gdrv_fmt_typename(char* dst, char* prefix, int ucase, char* src)
{
    int underscore = 0;
    int len = strlen(prefix);
    char* ret = dst;
    
    /* 1. skip base if match */
    if (strncasecmp(prefix, src, len) == 0)
	src += len;

    if (*src != '\0') {
	while(*src != '\0') {
	    if (isupper(*src)) {
		int n = 1;
		if (underscore)
		    *dst++ = '_';
		underscore = 1;
		*dst++ = ucase ? *src : tolower(*src);
		src++;
		if (isupper(src[0]) && isupper(src[1]) && !isupper(src[2])) {
		    *dst++ = ucase ? *src : tolower(*src);
		    src++;
		    *dst++ = '_';
		    *dst++ = ucase ? *src : tolower(*src);
		    src++;
		}
		else if (isupper(src[0]) && !isupper(src[1])) {
		    *dst++ = ucase ? *src : tolower(*src);
		    src++;
		}
		else {
		    while((*src != '\0') && isupper(*src)) {
			n++;
			*dst++ = ucase ? *src : tolower(*src);
			src++;
		    }
		}
	    }
	    else {
		*dst++ = ucase ? toupper(*src) : *src;
		src++;
	    }
	}
    }
    /* fixup for pointer type formatting */
    while((dst > ret) && (*(dst-1) == '*'))
	dst--;
    *dst = '\0';    
    return ret;
}

/* Get the Gtk/Gdk/Gnome/GL/GLU ... part of type name */
char* gdrv_type_prefix(char* dst, char* src)
{
    char* dst0 = dst;

    if (isupper(*src)) {
	*dst++ = *src++;
	if (isupper(*src)) {
	    while((*src != '\0') && isupper(*src))
		*dst++ = *src++;
	}
	else {
	    while((*src != '\0') && !isupper(*src))
		*dst++ = *src++;
	}
    }
    *dst = '\0';
    return dst0;
}

/*
** i.e convert a (GtkAdjustment,Gtk) => adjustment
** (GnomeDruidPageStandard,Gnome) => druid_page_standard
*/
char* gdrv_typename_to_basename(char* dst, char* prefix, char* src)
{
    return gdrv_fmt_typename(dst, prefix, 0, src);
}

/*
** Convert a gtk/gdk type to a lower case version
** i.e AaaBbbCcc => aaa_bbb_ccc
*/
char* gdrv_typename_to_cname(char* dst, char* src)
{
    return gdrv_fmt_typename(dst, "", 0, src);
}


char* gdrv_type_to_erlname(GtkType type)
{
    if (type == GTK_TYPE_STRING)
	return "gstring";
    return (char*) gtk_type_name(type);
}

GtkType gdrv_type_from_name(char* name, int indirection, 
			    arg_status_t status,
			    type_qualifier_t q)
{
    GtkType t;
    GtkType ft;

    if (strcmp(name, "GdkBitmap") == 0)
	t = GDK_TYPE_DRAWABLE;
    else if (strcmp(name, "GtkRequisition") == 0) {
	/* in gtk2.0 GtkRequisition is name "GtkTypeRequisition" */
	t = GTK_TYPE_REQUISITION;
    }
    else
	t = gtk_type_from_name(name);

    ft = GTK_FUNDAMENTAL_TYPE(t);

    if (q & Q_UNSIGNED) {
	switch(ft) {
	case GTK_TYPE_INT:  ft = t = GTK_TYPE_UINT; break;
	case GTK_TYPE_LONG: ft = t = GTK_TYPE_ULONG; break;
	case GTK_TYPE_CHAR: ft = t = GTK_TYPE_UCHAR; break;
	default: break;
	}
    }

    if ((ft == GTK_TYPE_CHAR) && (status == ARG_IN)) {
	if (indirection == 1)
	    return GTK_TYPE_STRING;
	else if (indirection == 2)
	    return GTK_TYPE_ARRAY_OF_STRING;
	else
	    return t;
    }
    else if (indirection == 1) {
	switch(ft) {
	case GTK_TYPE_NONE:    return GTK_TYPE_ARRAY_OF_VOID;
	case GTK_TYPE_UCHAR:   return GTK_TYPE_ARRAY_OF_UCHAR;
	case GTK_TYPE_BOOL:    return GTK_TYPE_ARRAY_OF_BOOL;    
	case GTK_TYPE_INT:     return GTK_TYPE_ARRAY_OF_INT;    
	case GTK_TYPE_UINT:    return GTK_TYPE_ARRAY_OF_UINT;    
	case GTK_TYPE_LONG:    return GTK_TYPE_ARRAY_OF_LONG;    
	case GTK_TYPE_ULONG:   return GTK_TYPE_ARRAY_OF_ULONG;    
	case GTK_TYPE_FLOAT:   return GTK_TYPE_ARRAY_OF_FLOAT;    
	case GTK_TYPE_DOUBLE:  return GTK_TYPE_ARRAY_OF_DOUBLE;
	case GTK_TYPE_STRING:  return GTK_TYPE_ARRAY_OF_STRING;
	case GTK_TYPE_ENUM:    return GTK_TYPE_ARRAY_OF_ENUM;
	case GTK_TYPE_FLAGS:   return GTK_TYPE_ARRAY_OF_FLAGS;
	default:
	    if (t == GDK_TYPE_POINT)
		return GDK_TYPE_ARRAY_OF_POINT;
	    else if (t == GDK_TYPE_SEGMENT)
		return GDK_TYPE_ARRAY_OF_SEGMENT;
	    else if (t == GTK_TYPE_ARG)
		return GTK_TYPE_ARRAY_OF_ARG;
	    else
		return t;
	}
    }
    return t;
}

char* gdrv_ext_to_typeidname(char* name)
{
    static char id[1024];
    int i;
    /* this is for Gtk, Gdk and Gnome like type system,
     * The reason for including the names (instead of just
     * GTK_TYPE_OBJECT) are for the type system to initialize the classes 
     */
    if (isupper(name[0])) {
	i = 1;
	id[0] = name[0];
	if (isupper(name[1])) {
	    while((name[i] != '\0') && isupper(name[i])) {
		id[i] = name[i];
		i++;
	    }
	    id[i] = '\0';
	}
	else {
	    while((name[i] != '\0') && !isupper(name[i])) {
		id[i] = toupper(name[i]);
		i++;
	    }
	    id[i] = '\0';
	}
	gdrv_fmt_typename(id+i+6, id, 1, name);
	memcpy(id+i, "_TYPE_", 6);
    }
    else {
	memcpy(id, "_TYPE_", 6);
	gdrv_fmt_typename(id+6, id, 1, name);
    }
    return id;
}


/* generate the GTK_TYPE stuff */
char* gdrv_typename_to_typeidname(char* name, int indirection,
				  type_qualifier_t q)
{
    GtkType t;
    GtkType ft;

    if ((t = gdrv_type_from_name(name, indirection, ARG_IN, q))
	== GTK_TYPE_INVALID) {
	fprintf(stderr, "type %s not found %d\n", name, (int) t);
	return "????";
    }

    if (IS_ARRAY(t)) {
	GtkType etype = array_element_type(t);
	switch(GTK_FUNDAMENTAL_TYPE(etype)) {
	case GTK_TYPE_NONE:    return "GTK_TYPE_ARRAY_OF_VOID";
	case GTK_TYPE_CHAR:    return "GTK_TYPE_ARRAY_OF_CHAR";
	case GTK_TYPE_UCHAR:   return "GTK_TYPE_ARRAY_OF_UCHAR";
	case GTK_TYPE_BOOL:    return "GTK_TYPE_ARRAY_OF_BOOL";
	case GTK_TYPE_INT:     return "GTK_TYPE_ARRAY_OF_INT";
	case GTK_TYPE_UINT:    return "GTK_TYPE_ARRAY_OF_UINT";
	case GTK_TYPE_LONG:    return "GTK_TYPE_ARRAY_OF_LONG";    
	case GTK_TYPE_ULONG:   return "GTK_TYPE_ARRAY_OF_ULONG";
	case GTK_TYPE_FLOAT:   return "GTK_TYPE_ARRAY_OF_FLOAT";    
	case GTK_TYPE_DOUBLE:  return "GTK_TYPE_ARRAY_OF_DOUBLE";
	case GTK_TYPE_STRING:  return "GTK_TYPE_ARRAY_OF_STRING";
	case GTK_TYPE_ENUM:    return "GTK_TYPE_ARRAY_OF_ENUM";
	case GTK_TYPE_FLAGS:   return "GTK_TYPE_ARRAY_OF_FLAGS";
	case GTK_TYPE_BOXED:
	    if (t == GDK_TYPE_ARRAY_OF_POINT)
		return "GDK_TYPE_ARRAY_OF_POINT";
	    else if (t == GDK_TYPE_ARRAY_OF_SEGMENT)
		return "GDK_TYPE_ARRAY_OF_SEGMENT";
	    else
		return "GTK_TYPE_ARRAY_OF_BOXED";
	    break;
	case GTK_TYPE_POINTER:
	    if (t == GTK_TYPE_ARRAY_OF_ARG)
		return "GTK_TYPE_ARRAY_OF_ARG";
	    return "GTK_TYPE_ARRAY_OF_POINTER";
	case G_TYPE_OBJECT:
	    return "GTK_TYPE_ARRAY_OF_OBJECT";
	default:
	    return "????";
	}
    }

    ft = GTK_FUNDAMENTAL_TYPE(t);

    switch(ft) {
    case GTK_TYPE_NONE:    return "GTK_TYPE_NONE";
    case GTK_TYPE_CHAR:    return "GTK_TYPE_CHAR";
    case GTK_TYPE_UCHAR:   return "GTK_TYPE_UCHAR";
    case GTK_TYPE_BOOL:    return "GTK_TYPE_BOOL";
    case GTK_TYPE_INT:     return "GTK_TYPE_INT";
    case GTK_TYPE_UINT:    return "GTK_TYPE_UINT";
    case GTK_TYPE_LONG:    return "GTK_TYPE_LONG";    
    case GTK_TYPE_ULONG:   return "GTK_TYPE_ULONG";
    case GTK_TYPE_FLOAT:   return "GTK_TYPE_FLOAT";
    case GTK_TYPE_DOUBLE:  return "GTK_TYPE_DOUBLE";
    case GTK_TYPE_STRING:  return "GTK_TYPE_STRING";
    case GTK_TYPE_ENUM:    return "GTK_TYPE_ENUM";
    case GTK_TYPE_FLAGS:   return "GTK_TYPE_FLAGS";
    case GTK_TYPE_POINTER:
	if (t == GTK_TYPE_ETERM)
	    return "GTK_TYPE_ETERM";
	else if (t == GTK_TYPE_GLIST)
	    return "GTK_TYPE_GLIST";
	else if (t == GTK_TYPE_GSLIST)
	    return "GTK_TYPE_GSLIST";
	else if (t == GTK_TYPE_ARG)
	    return "GTK_TYPE_ARG";
	return "GTK_TYPE_POINTER";
#if GTK_VERSION >= GTK_VERS(2,0,0)
    case G_TYPE_INTERFACE:
#endif
    case GTK_TYPE_BOXED:
    case G_TYPE_OBJECT:
	return gdrv_ext_to_typeidname(name);

    default:
	fprintf(stderr, "type %s not found fundamental=%d\n", name, (int)ft);
    }
    return "????";
}


GtkType array_element_type(GtkType array_type)
{
    if (array_type == GTK_TYPE_ARRAY_OF_CHAR)
	return GTK_TYPE_CHAR;
    else if (array_type == GTK_TYPE_ARRAY_OF_STRING)
	return GTK_TYPE_STRING;
    else if (array_type == GDK_TYPE_ARRAY_OF_POINT)
	return GDK_TYPE_POINT;
    else if (array_type == GTK_TYPE_ARRAY_OF_ARG)
	return GTK_TYPE_ARG;
    else if (array_type == GDK_TYPE_ARRAY_OF_SEGMENT)
	return GDK_TYPE_SEGMENT;
    else if (array_type == GTK_TYPE_ARRAY_OF_UCHAR)
	return GTK_TYPE_UCHAR;
    else if (array_type == GTK_TYPE_ARRAY_OF_BOOL)
	return GTK_TYPE_BOOL;
    else if (array_type == GTK_TYPE_ARRAY_OF_INT)
	return GTK_TYPE_INT;
    else if (array_type == GTK_TYPE_ARRAY_OF_UINT)
	return GTK_TYPE_UINT;
    else if (array_type == GTK_TYPE_ARRAY_OF_LONG)
	return GTK_TYPE_LONG;
    else if (array_type == GTK_TYPE_ARRAY_OF_ULONG)
	return GTK_TYPE_ULONG;
    else if (array_type == GTK_TYPE_ARRAY_OF_FLOAT)
	return GTK_TYPE_FLOAT;
    else if (array_type == GTK_TYPE_ARRAY_OF_DOUBLE)
	return GTK_TYPE_DOUBLE;
    else if (array_type == GTK_TYPE_ARRAY_OF_STRING)
	return GTK_TYPE_STRING;
    else if (array_type == GTK_TYPE_ARRAY_OF_STRING)
	return GTK_TYPE_STRING;
    else if (array_type == GTK_TYPE_ARRAY_OF_ENUM)
	return GTK_TYPE_ENUM;
    else if (array_type == GTK_TYPE_ARRAY_OF_FLAGS)
	return GTK_TYPE_FLAGS;
    else if (array_type == GTK_TYPE_ARRAY_OF_BOXED)
	return GTK_TYPE_BOXED;
    else if (array_type == GTK_TYPE_ARRAY_OF_POINTER)
	return GTK_TYPE_POINTER;
    else if (array_type == GTK_TYPE_ARRAY_OF_OBJECT)
	return GTK_TYPE_OBJECT;
    else if (array_type == GTK_TYPE_ARRAY_OF_VOID)
	return GTK_TYPE_NONE;
    else
	return GTK_TYPE_INVALID;
}
