/*
** Check if the erl_interface support closures (funs) 
*/
#include <stdio.h>
#include <ei.h>
#include <erl_interface.h>

main()
{
    unsigned char i_buf[1024];
    unsigned char o_buf[1024];
    int n;

    erl_init(NULL, 0);

    while((n = read(0, i_buf, 2)) == 2) {
	char* res;
	int ver;
	ETERM* term;
	int i_x = 0;
	int len = (i_buf[0] << 8) + i_buf[1];

	if (len > 1024) {
	    fprintf(stderr, "eiconf: buffer to big\n");
	    exit(1);
	}
	if (read(0, i_buf, len) < len) {
	    perror("eiconf: read error");
	    exit(1);
	}

	if (ei_decode_version(i_buf, &i_x, &ver) < 0) {
	    fprintf(stderr, "eiconf: bad binary data (version)\n");

	    exit(1);
	}

	if (ei_decode_term(i_buf, &i_x, (void*) &term) < 0) {
	    int i;
	    fprintf(stderr, "[%d", i_buf[0]);
	    for (i = 1; i < len; i++)
		fprintf(stderr, ",%d", i_buf[i]);
	    fprintf(stderr, "]\n");
	    res = "false";
	}
	else
	    res = "true";
	len = strlen(res);
	o_buf[0] = 0;
	o_buf[1] = len;
	strcpy(o_buf+2, res);
	write(1, o_buf, len+2);
    }

    if (n == 0)
	exit(0);
    else {
	perror("eiconf: read error");
	exit(1);
    }
}
