-module(eiconf).
-export([start/0, fun_ext/0, fun_ari/0, lib_dir/0]).

-export([fun_test1/2]).

start() ->
    io:put_chars([code:lib_dir(erl_interface),$\n]),
    halt().

fun_test1(X,Y) ->
    X+Y.

fun_test2(X,Y) ->
    X+Y.

fun_list() ->
    CL0 = 15,
    [ 
      {0, fun() -> true end},
      {1, fun(A1) -> true end},
      {2, fun(A1,A2) -> true end},
      {3, fun(A1,A2,A3) -> true end},
      {4, fun(A1,A2,A3,A4) -> true end},
      {5, fun(A1,A2,A3,A4,A5) -> true end},
      {1, fun(A1) -> A1+CL0+7 end},
      {2, fun fun_test1/2},
      {2, binary_to_term(term_to_binary(fun(A1,A2) -> A1+A2+CL0 end))}
     ].

fun_ext() ->
    Port = open_port({spawn, "./eiconf"}, [{packet,2}]),
    Answer = test_fun_ext(Port, fun_list()),
    io:put_chars([Answer, $\n]),
    erlang:port_close(Port),
    halt().

test_fun_ext(Port, [{A,F} | Fs]) ->
    Port ! {self(),{command,term_to_binary(F)}},
    receive
	{Port,{data,"true"}} ->
	    test_fun_ext(Port, Fs);
	{Port,{data,"false"}} ->  
	    "false"
    after 1000 ->
	    "false"
    end;
test_fun_ext(Port, []) ->
    "true".


fun_ari() ->
    case catch test_ari() of
	ok         -> io:put_chars("true\n");
	{'EXIT',_} -> io:put_chars("false\n");
	buggy ->  io:put_chars("buggy\n")
    end,
    halt().

test_ari() ->
    test_ari(fun_list()).

test_ari([{Ari, F} | Fs]) ->
    {arity,A} = erlang:fun_info(F, arity),    
    if Ari == A ->
	    test_ari(Fs);
       true ->
	    buggy
    end;
test_ari([]) ->
    ok.

arity(F) ->
    {arity,A} = erlang:fun_info(F, arity),
    A.

lib_dir() ->
    io:put_chars([code:lib_dir(),$\n]),
    halt().

	    
		



    
