%%% File    : arrow.erl
%%% Author  : Tony Rogvall <tony@bit.hemma.se>
%%% Purpose : arrow example
%%% Created : 29 Nov 2000 by Tony Rogvall <tony@bit.hemma.se>

-module(arrow).
-author('tony@bit.hemma.se').

-compile(export_all).


%% Create an Arrow widget with the specified parameters
%% and pack it into a button 
create_arrow_button(Arrow_type,Shadow_type) ->
    Button = gtk:button_new(),
    Arrow = gtk:arrow_new(Arrow_type, Shadow_type),
    gtk:container_add (Button, Arrow),
    gtk:widget_show(Button),
    gtk:widget_show(Arrow),
    Button.

run() ->
    gtk:start(),
    spawn_link(?MODULE, main, []).

main() ->
    %% Create a new window */
    Window = gtk:window_new ('GTK_WINDOW_TOPLEVEL'),

    gtk:window_set_title (Window, "Arrow Buttons"),

    %% It's a good idea to do this for all windows. 
    gtk:signal_connect(Window, 'destroy',
		       fun(_,_) -> gtk:main_quit() end, []),

    %% Sets the border width of the window. 
    gtk:container_set_border_width (Window, 10),

    %% Create a box to hold the arrows/buttons 
    Box = gtk:hbox_new (false, 0),
    gtk:container_set_border_width (Box, 2),
    gtk:container_add (Window, Box),

    %% Pack and show all our widgets 
    gtk:widget_show(Box),

    Button1 = create_arrow_button('GTK_ARROW_UP', 'GTK_SHADOW_IN'),
    gtk:box_pack_start (Box, Button1, false, false, 3),

    Button2 = create_arrow_button('GTK_ARROW_DOWN', 'GTK_SHADOW_OUT'),
    gtk:box_pack_start (Box, Button2, false, false, 3),
  
    Button3 = create_arrow_button('GTK_ARROW_LEFT', 'GTK_SHADOW_ETCHED_IN'),
    gtk:box_pack_start (Box, Button3, false, false, 3),
  
    Button4 = create_arrow_button('GTK_ARROW_RIGHT', 'GTK_SHADOW_ETCHED_OUT'),
    gtk:box_pack_start (Box, Button4, false, false, 3),
    
    gtk:widget_show (Window),
  
    %% Rest in gtk_main and wait for the fun to begin! 
    gtk:main(),
  
    0.

%% example-end 

