%%% File    : aspectframe.erl
%%% Author  : Tony Rogvall <tony@bit.hemma.se>
%%% Purpose : aspectframe example
%%% Created :  7 Dec 2000 by Tony Rogvall <tony@bit.hemma.se>

-module(aspectframe).
-author('tony@bit.hemma.se').

-compile(export_all).

%% example-start aspectframe aspectframe.c 

-include("../include/gtk.hrl").

run() ->
    gtk:start(),
    spawn_link(?MODULE, main, []).
   
main( ) ->
    Window = gtk:window_new ('GTK_WINDOW_TOPLEVEL'),
    gtk:window_set_title (?GTK_WINDOW (Window), "Aspect Frame"),
    gtk:signal_connect (?GTK_OBJECT (Window), 'destroy',
			fun(_,_) -> gtk:main_quit() end, []),
    gtk:container_set_border_width (?GTK_CONTAINER (Window), 10),
   
    %% Create an aspect_frame and add it to our toplevel window 
   
    Aspect_frame = gtk:aspect_frame_new ("2x1", %% label 
                                         0.5,   %% center x 
                                         0.5,   %% center y 
                                         2,     %% xsize/ysize = 2 
                                         false),%% ignore child's aspect 
   
    gtk:container_add (?GTK_CONTAINER(Window), Aspect_frame),
    gtk:widget_show (Aspect_frame),
   
    %% Now add a child widget to the aspect frame 
   
    Drawing_area = gtk:drawing_area_new (),
   
    %% Ask for a 200x200 window, but the AspectFrame will give us a 200x100
    %% window since we are forcing a 2x1 aspect ratio */
    gtk:widget_set_usize (Drawing_area, 200, 200),
    gtk:container_add (?GTK_CONTAINER(Aspect_frame), Drawing_area),
    gtk:widget_show (Drawing_area),
   
    gtk:widget_show (Window),
    gtk:main (),
    0.

%% example-end 

