%%% File    : event.erl
%%% Author  : Tony Rogvall <tony@bit.hemma.se>
%%% Purpose : Event test
%%% Created : 15 Nov 2000 by Tony Rogvall <tony@bit.hemma.se>

-module(event).
-author('tony@bit.hemma.se').

-export([run/0, main/0]).

-include("../include/gdk.hrl").

event(Window, Event, Data) ->
    io:format("event(~p): ~p\n", [Window, Event]),
    case ?GDK_EVENT_TYPE(Event) of
	'GDK_KEY_PRESS' ->
	    case Event#gdk_event_key.string of
		"q" -> gtk:main_quit();
		_ -> true
	    end;
	_ ->
	    true
    end.


delete_event(Window, _, Data) ->
    gtk:quit().

run() ->
    gtk:start(),
    spawn_link(?MODULE, main, []).

main() ->
    Window = gtk:window_new('GTK_WINDOW_DIALOG'),

    gtk:widget_set_events(Window, ?GDK_ALL_EVENTS_MASK),

    %% catch all events
    gtk:signal_connect(Window, 'delete_event', fun delete_event/3, []),

    gtk:signal_connect(Window, 'event', fun event/3, []),

    gtk:widget_show(Window),
    gtk:main().

