%%% File    : eventbox.erl
%%% Author  : Tony Rogvall <tony@bit.hemma.se>
%%% Purpose : eventbox example
%%% Created : 19 Dec 2000 by Tony Rogvall <tony@bit.hemma.se>

-module(eventbox).
-author('tony@bit.hemma.se').

-compile(export_all).
%%-export([Function/Arity, ...]).


%% example-start eventbox 

-include("../include/gtk.hrl").
-include("../include/gdk.hrl").

run() ->
    gtk:start(),
    spawn_link(?MODULE, main, []).

main( ) ->
    Window = gtk:window_new ('GTK_WINDOW_TOPLEVEL'),
    
    gtk:window_set_title (?GTK_WINDOW (Window), "Event Box"),
    
    gtk:signal_connect (?GTK_OBJECT (Window), 'destroy',
			fun(_,_) -> gtk:main_quit() end, ?NULL),
    
    gtk:container_set_border_width (?GTK_CONTAINER (Window), 10),
    
    %% Create an EventBox and add it to our toplevel window 
    
    Event_box = gtk:event_box_new (),
    gtk:container_add (?GTK_CONTAINER(Window), Event_box),
    gtk:widget_show (Event_box),
    
    %% Create a long label 
    
    Label = gtk:label_new ("Click here to quit, quit, quit, quit, quit"),
    gtk:container_add (?GTK_CONTAINER (Event_box), Label),
    gtk:widget_show (Label),
    
    %% Clip it short. 
    gtk:widget_set_usize (Label, 110, 20),
    
    %% And bind an action to it 
    gtk:widget_set_events (Event_box, ?GDK_BUTTON_PRESS_MASK),
    gtk:signal_connect (?GTK_OBJECT(Event_box), 'button_press_event',
			fun(_,_,_) -> gtk:main_quit() end, ?NULL),
    
    %% Yet one more thing you need an X window for ... 
    
    gtk:widget_realize (Event_box),
    GdkWindow = gtk:widget_get_window(Event_box),
    gdk:window_set_cursor (GdkWindow, gdk:cursor_new ('GDK_HAND1')),
    
    gtk:widget_show (Window),
    
    gtk:main ().


%% example-end 
