%%% File    : filesel.erl
%%% Author  : Tony Rogvall <tony@bit.hemma.se>
%%% Purpose : filesel example
%%% Created : 10 Dec 2000 by Tony Rogvall <tony@bit.hemma.se>

-module(filesel).
-author('tony@bit.hemma.se').

-compile(export_all).

%% example-start filesel filesel.c */

-include("../include/gtk.hrl").

%% Get the selected filename and print it to the console 
file_ok_sel(W, Fs) ->
    io:format("~s\n", [gtk:file_selection_get_filename(
			 ?GTK_FILE_SELECTION (Fs))]).

destroy(Widget, Data) ->
    gtk:main_quit ().

run() ->
    gtk:start(),
    spawn_link(?MODULE, main, []).

main() ->
    %% Create a new file selection widget 
    Filew = gtk:file_selection_new ("File selection"),
    gtk:signal_connect(?GTK_OBJECT (Filew), 'destroy',
		       fun destroy/2, Filew),
    %% Connect the ok_button to file_ok_sel function 
    gtk:signal_connect (gtk:file_selection_get_ok_button(Filew),
			'clicked', 
			fun file_ok_sel/2, Filew ),
    
    %% Connect the cancel_button to destroy the widget 
    gtk:signal_connect(gtk:file_selection_get_cancel_button(Filew),
		       'clicked',
		       fun(_, W) -> gtk:widget_destroy(W) end,
		       ?GTK_OBJECT (Filew)),
    
    %% Lets set the filename, as if this were a save dialog, and we are giving
    %% a default filename 
    gtk:file_selection_set_filename (?GTK_FILE_SELECTION(Filew), 
				     "penguin.png"),
    
    gtk:widget_show(Filew),
    gtk:main(),
    0.

%% example-end */
