%%% File    : gnome_wiz.erl
%%% Author  : Tony Rogvall <tony@bit.hemma.se>
%%% Description : Gnome druid example
%%% Created : 11 Apr 2001 by Tony Rogvall <tony@bit.hemma.se>

-module(gnome_wiz).

-author('tony@bit.hemma.se').

-compile(export_all).

%% example-start base base.c

-include("../include/gtk.hrl").

run() ->
    gtk:start(),
    spawn_link(?MODULE, main, []).

delete_event(Window, Event, Data) ->
    gtk:main_quit().


main( ) ->
    Window = gtk:window_new ('GTK_WINDOW_TOPLEVEL'),
    gtk:signal_connect(Window, 'delete_event',fun delete_event/3, []),
    gtk:container_set_border_width(Window, 10),
    
    Druid = gnome_druid:new(),
    gtk:container_add(Window, Druid),
    gtk:signal_connect(Druid, 'cancel',
		       fun(_, _) -> gtk:main_quit() end, []),
    gtk:widget_show  (Druid),

    Logo  = gdk_imlib:load_image("powered.png"),
    Water = gdk_imlib:load_image("bil.png"),
    
    Start = gnome_druid:page_start_new(),
    gnome_druid:page_start_set_title(Start, "Start page"),
    gnome_druid:page_start_set_text(Start,  "Click Click & Click"),
    gnome_druid:page_start_set_logo(Start, Logo),
    gnome_druid:page_start_set_watermark(Start, Water),
    gnome_druid:append_page(Druid, Start),
    gtk:widget_show  (Start),

    Page1 = gnome_druid:page_standard_new(),
    gnome_druid:page_standard_set_title(Page1, "This is Page1"),
    gnome_druid:page_standard_set_logo(Page1, Logo),
    gnome_druid:append_page(Druid, Page1),
    %% Page1 content
    Vbox1 = gnome_druid:page_standard_get_vbox(Page1),
    Page1Check = gtk:check_button_new_with_label("View Readme"),
    gtk:box_pack_start(Vbox1, Page1Check, false, false, 1),
    gtk:widget_show(Page1Check),
    gtk:widget_show  (Page1),

    Page2 = gnome_druid:page_standard_new(),
    gnome_druid:page_standard_set_title(Page2, "This is Page2"),
    gnome_druid:page_standard_set_logo(Page2, Logo),
    gnome_druid:append_page(Druid, Page2),
    %% Page2 content
    gtk:widget_show  (Page2),

    Page3 = gnome_druid:page_standard_new(),
    gnome_druid:page_standard_set_title(Page3, "This is Page3"),
    gnome_druid:page_standard_set_logo(Page3, Logo),
    gnome_druid:append_page(Druid, Page3),
    %% Page3 content
    gtk:widget_show  (Page3),

    Finish = gnome_druid:page_finish_new(),
    gnome_druid:page_finish_set_title(Finish, "Finish page"),
    gnome_druid:page_finish_set_text(Finish,  "Just one more Click"),
    gnome_druid:page_finish_set_logo(Finish, Logo),
    gnome_druid:append_page(Druid, Finish),
    %% Finish action
    gtk:signal_connect(Finish, 'finish',
		       fun(_, _, _) -> gtk:main_quit() end, []),
    gtk:widget_show  (Finish),

    gtk:widget_show  (Window),
    gtk:main ().

%% example-end 



