%%% File    : helloworld2.erl
%%% Author  : Tony Rogvall <tony@bit.hemma.se>
%%% Purpose : 
%%% Created : 16 Nov 2000 by Tony Rogvall <tony@bit.hemma.se>

-module(helloworld2).
-author('tony@bit.hemma.se').

-compile(export_all).
%%-export([Function/Arity, ...]).

event(Window, Event, Data) ->
    io:format("event(~p): ~p\n", [Window, Event]),
    false.

callback(Window, Data) ->
    io:format("~s was pressed\n", [Data]).

delete_event(Window, Ev, _) ->
    io:format("delete_event: Obj = ~p, Event = ~p\n", [Window, Ev]),
    gtk:main_quit().

run() ->
    gtk:start(),
    spawn_link(?MODULE, main, []).


main() ->
    Window = gtk:window_new('GTK_WINDOW_TOPLEVEL'),
    %%
    gtk:signal_connect(Window, 'delete_event', fun delete_event/3, []),

    gtk:container_set_border_width(Window, 10),

    Box1 = gtk:hbox_new(false, 0),

    gtk:container_add(Window, Box1),
    
    Button1 = gtk:button_new_with_label("Button 1"),

    {ok,B1} = gtk:signal_connect(Button1, 'clicked', fun callback/2, 
				"button 1"),

    gtk:box_pack_start(Box1, Button1, true, true, 0),

    gtk:widget_show(Button1),


    Button2 = gtk:button_new_with_label("Button 2"),

    {ok,B2} = gtk:signal_connect(Button2, 'clicked', fun callback/2, 
				 "button 2"),

    gtk:box_pack_start(Box1, Button2, true, true, 0),

    gtk:widget_show(Box1),

    gtk:widget_show(Button2),    

    gtk:widget_show(Window),    

    gtk:main().

