%%% File    : input.erl
%%% Author  :  <tony@orre.bluetail.com>
%%% Purpose : example input
%%% Created : 18 Dec 2000 by  <tony@orre.bluetail.com>

-module(input).
-author('tony@orre.bluetail.com').

-compile(export_all).

-include("../include/gtk.hrl").

-record(state, 
	{ 
	  button,
	  window
	 }).

run() ->
    gtk:start(),
    spawn_link(?MODULE, main, []).


input1(Message, St) ->
    io:format("input1: got message ~p\n", [Message]),
    if Message == input1 ->
	    W = gtk:bin_get_child(?GTK_BIN(St#state.button)),
	    gtk:label_set_text(?GTK_LABEL(W), "Hello again"),
	    true;
       true ->
	    false
    end.

input2(Message, St) ->
    io:format("input2: got message ~p\n", [Message]),
    if Message == input2 ->
	    W = gtk:bin_get_child(?GTK_BIN(St#state.button)),
	    gtk:label_set_text(?GTK_LABEL(W), "Go away"),
	    true;
       true ->
	    false
    end.

timeout(Window) ->
    Count = get(counter) + 1,
    io:format("timeout: called counter=~w\n", [Count]),
    Fmt = io_lib:format("INPUT: ~w", [Count]),
    gtk:window_set_title(Window, lists:flatten(Fmt)),
    put(counter, Count),
    true.


main() ->
    Window = gtk:window_new('GTK_WINDOW_TOPLEVEL'),

    gtk:window_set_title(Window, "INPUT: 0"),
    put(counter, 0),

    gtk:signal_connect(Window, 'destroy', 
		       fun(_,_) -> gtk:main_quit() end, []),

    Box = gtk:hbutton_box_new(),

    Button = gtk:button_new_with_label("Hello world"),
    gtk:signal_connect(Button, 'clicked',
		       fun(_,_) ->
			       io:format("Hello world\n")
		       end, []),
    gtk:container_add(Box, Button),
    gtk:widget_show(Button),

    Quit = gtk:button_new_with_label("Quit"),
    gtk:signal_connect(Quit, 'clicked',
		       fun(_,_) -> gtk:main_quit() end,
		       []),
    gtk:container_add(Box, Quit),
    gtk:widget_show(Quit),

    gtk:container_add(Window, Box),    
    gtk:widget_show(Box),    
    gtk:widget_show(Window),    

    I1 = gtk:input_add(fun input1/2),

    I2 = gtk:input_add(fun input2/2),
    
    I3 = gtk:timeout_add(1000, fun timeout/1, Window),

    gtk:main(#state { button = Button }).

    



