%%% File    : ip_test.erl
%%% Author  : Tony Rogvall <tony@bit.hemma.se>
%%% Purpose : IP Entry example
%%% Created : 27 Dec 2000 by Tony Rogvall <tony@bit.hemma.se>

-module(ip_test).
-author('tony@bit.hemma.se').

-compile(export_all).

-include("../include/gtk.hrl").

run() ->
    gtk:start(),
    spawn_link(?MODULE, main, []).

main( ) ->
    %% create a new window 
    Window = gtk:window_new('GTK_WINDOW_TOPLEVEL'),
    gtk:widget_set_usize( ?GTK_WIDGET (Window), 200, 100),
    gtk:window_set_title(?GTK_WINDOW (Window), "GTK IP Entry"),
    gtk:signal_connect(?GTK_OBJECT (Window), 'delete_event',
                       fun(_,_,_) -> gtk:main_quit() end, []),

    Vbox = gtk:vbox_new (false, 0),
    gtk:container_add (?GTK_CONTAINER (Window), Vbox),
    gtk:widget_show (Vbox),

    Entry = ip_entry:new_with_ip({127,0,0,1}),
    gtk:box_pack_start (?GTK_BOX (Vbox), Entry, true, true, 0),
    gtk:widget_show (Entry),

    Button = gtk:button_new_with_label ("Close"),
    gtk:signal_connect(?GTK_OBJECT (Button), 'clicked',
		       fun(_, _) -> gtk:main_quit() end,
		       Window),
    gtk:box_pack_start (?GTK_BOX (Vbox), Button, true, true, 0),
    ?GTK_WIDGET_SET_FLAGS(Button, ?GTK_CAN_DEFAULT),
    gtk:widget_grab_default(Button),

    gtk:widget_show(Button),
    gtk:widget_show(Window),
    gtk:main().
