-module(scroll).

-include("../include/gtk.hrl").

-export([run/0, main/0]).


close_application(Widget, Event, Data) ->
    gtk:main_quit().

run() ->
    gtk:start(),    
    spawn(?MODULE, main, []).

main() ->
    Window = gtk:window_new('GTK_WINDOW_TOPLEVEL'),

    gtk:signal_connect(Window, 'delete_event', 
		       fun close_application/3, []),

    gtk:container_set_border_width(Window, 10),
    Adjustment = gtk:adjustment_new(0, 0, 10, 1, 1, 1),
    HScrollbar = gtk:hscrollbar_new(Adjustment),

    gtk:signal_connect(Adjustment,'value_changed', 
		       fun (Adj, _Data) ->
			       Vs = gtk:widget_get(Adjustment,
						   [value, upper, lower]),
			       io:format("value = ~p\n", [Vs]),
			       false
		       end, []),
    
    gtk:container_add(Window, HScrollbar),
    gtk:widget_show(HScrollbar),
    gtk:widget_show(Window),
    gtk:main().


    

    
