%%% File    : table.erl
%%% Author  : Tony Rogvall <tony@bit.hemma.se>
%%% Description : 
%%% Created : 17 Nov 2000 by Tony Rogvall <tony@bit.hemma.se>

-module(table).

-export([run/0, main/0]).

callback(Widget, Data ) ->
    io:format("Hello again - ~s was pressed\n",[Data]).

delete_event(Widget, Data) -> 
    io:format("delete event/2\n"),
    gtk:main_quit().

delete_event(Widget, Event, Data) -> 
    io:format("delete event/3\n"),
    gtk:main_quit().

run() ->
    gtk:start(),    
    spawn_link(?MODULE, main, []).

main() ->
    Window = gtk:window_new ('GTK_WINDOW_TOPLEVEL'),

    gtk:window_set_title (Window, "Table"),

    gtk:signal_connect (Window, 'delete_event',
                        fun delete_event/3, []),

    gtk:container_set_border_width (Window, 20),

    Table = gtk:table_new(2, 2, true),

    gtk:container_add (Window, Table),

    Button1 = gtk:button_new_with_label ("button 1"),
    
    gtk:signal_connect (Button1, 'clicked', fun callback/2, "button 1"),

    gtk:table_attach_defaults(Table, Button1, 0, 1, 0, 1),

    gtk:widget_show (Button1),

    Button2 = gtk:button_new_with_label ("button 2"),

    gtk:signal_connect (Button2, 'clicked', fun callback/2, "button 2"),

    gtk:table_attach_defaults(Table, Button2, 1, 2, 0, 1),

    gtk:widget_show (Button2),

    Button3 = gtk:button_new_with_label ("Quit"),

    gtk:signal_connect (Button3, 'clicked', fun delete_event/2, []),

    gtk:table_attach_defaults (Table, Button3, 0, 2, 1, 2),

    gtk:widget_show (Button3),

    gtk:widget_show (Table),
    gtk:widget_show (Window),
    gtk:main().


