module gdk_pixbuf_loader;

#include <gdk-pixbuf/gdk-pixbuf-loader.h>

typedef GtkObject GdkPixbuf;
typedef GtkObject GdkPixbufLoader;
typedef GtkObject GdkPixbufAnimation;

/* GtkPixbufLoader -> GtkObject
 * Signals:
 *           area_prepared  (GdkPixbufLoader *)
 *           area_update    (GdkPixbufLoader *,
                             guint x, guint y, guint width, guint height)
 *           frame_done     (GdkPixbufLoader *loader, GdkPixbufFrame *frame)
 *           animation_done (GdkPixbufLoader *loader)
 *           closed         (GdkPixbufLoader *loader)
 */

GdkPixbufLoader    *gdk_pixbuf_loader_new           (void);
gboolean            gdk_pixbuf_loader_write         (GdkPixbufLoader *loader,
                                                     const guchar    *buf,
                                                     /* size_t*/ int count);
GdkPixbuf          *gdk_pixbuf_loader_get_pixbuf    (GdkPixbufLoader *loader);
GdkPixbufAnimation *gdk_pixbuf_loader_get_animation (GdkPixbufLoader *loader);
void                gdk_pixbuf_loader_close         (GdkPixbufLoader *loader);

