
#include <gtk/gtk.h>
#include <gdk-pixbuf/gdk-pixbuf.h>
#include "gtk_drv_api.h"

void* gdrv_gdk_pixbuf_get_pixels(const GdkPixbuf* pixbuf)
{
    int height = gdk_pixbuf_get_height(pixbuf);
    int width  = gdk_pixbuf_get_width(pixbuf);
    int rowstride = gdk_pixbuf_get_rowstride(pixbuf);
    int n_channels = gdk_pixbuf_get_n_channels(pixbuf);
    int bits_per_sample = gdk_pixbuf_get_bits_per_sample(pixbuf);
    int size = (height-1) * rowstride +
	width * ((n_channels * bits_per_sample + 7) / 8);
    void* pixels = gdk_pixbuf_get_pixels(pixbuf);
    GtkArray* arr;

    arr = (GtkArray*) gdrv_stack_alloc(sizeof(GtkArray));
    arr->elem_type = GTK_TYPE_NONE;
    arr->size = size;
    arr->vector = pixels;

    return (void*) arr;
}

