#!/bin/sh
#  The glade2erl translator
#
#  usage:
#  glade2erl -compile [-nocb] [-nomain] [-noui] [-o <dir>] <file>
#  glade2erl -client [-port <p>] [-host <h>] <file>
#  glade2erl -server  [-port <p>] [-ifaddr <addr>]
#  glade2erl -view <file>
#
MODE=view
FILE=nofile
args=""

while [ $# != 0 ] 
do
    case "$1" in
    "-c")
      MODE=compile;
      shift;;
    "-compile")
      MODE=compile;
      shift;;
    "-client")
      MODE=client;
      shift;;
    "-server")
      MODE=server;
      shift;;
    "-view")
      MODE=view;
      shift;;
    "-v")
      MODE=view;
      shift;;
    "-port")
      shift;
      PORT=$1;
      args="$args -port $PORT";
      shift;;
    "-host")
      shift;
      HOST=$1;
      args="$args -host $HOST";
      shift;;
    "-ifaddr")
      shift;
      ADDR=$1;
      args="$args -ifaddr $ADDR";
      shift;;
    "-nocb")
      args="$args -nocb";
      shift;;
    "-noui")
      args="$args -noui";
      shift;;
    "-nomain")
      args="$args -nomain";
      shift;;
    "-o")
      shift;
      DIR=$1;
      args="$args -o $DIR";
      shift;;
    -*)
      echo "
usage:
  glade2erl -compile [-nocb] [-nomain] [-noui] [-o <dir>] <file>
  glade2erl -client [-port <p>] [-host <h>] <file>
  glade2erl -server  [-port <p>] [-ifaddr <addr>]
  glade2erl -view <file>
"
    exit 1;;

    *)
      FILE=$1
      shift;;
    esac
done

if [ "$MODE" = "server" ];
then
    # -detached
    exec erl -noshell -s glade2erl server nofile $args
else
    exec erl -noshell -s glade2erl $MODE $FILE $args
fi

