%%% File    : gnome_canvas.erl
%%% Author  : Tony Rogvall <tony@bit.hemma.se>
%%% Description : GnomeCanvas interface
%%% Created :  4 Dec 2001 by Tony Rogvall <tony@bit.hemma.se>

-module(gnome_canvas).

-compile(export_all).

%% Wrapper for gdk calls
fcall(Mod, Fun, Args) ->
    gtk:fcall(Mod, Fun, Args).

fnew(Mod, Fun, Args) ->
    gtk:fnew(Mod, Fun, Args).

%% Enum wrapper
enum(Type, Enum) ->
    gtk:enum(Type, Enum).

flags(Type, Enum) ->
    gtk:flags(Type, Enum).

%% wrapper
points_unref(GnomeCanvasPoints) ->
    points_free(GnomeCanvasPoints).

item_new(Parent, Type, Args) ->
    item_newv(Parent, Type, length(Args), gtk:enc_set_args({Type,0},Args)).

item_set(Item, Args) ->
    item_setv(Item, length(Args), gtk:enc_set_args(Item,Args)).

-include("../priv/src/gnome_canvas.inc").


