
module gnome_druid;

#include <gnome.h>

typedef GtkObject      GnomeDruid;
typedef GtkObject      GnomeDruidPage;
typedef GtkObject      GnomeDruidPageStandard;
typedef GtkObject      GnomeDruidPageStart;
typedef GtkObject      GnomeDruidPageFinish;
typedef gpointer       GdkImlibImage;

/* Gnome druid */

new GtkWidget *gnome_druid_new                   (void);
void	   gnome_druid_set_buttons_sensitive (GnomeDruid *druid,
					      gboolean back_sensitive,
					      gboolean next_sensitive,
					      gboolean cancel_sensitive);

void	   gnome_druid_set_show_finish       (GnomeDruid *druid, gboolean show_finish);

void       gnome_druid_prepend_page          (GnomeDruid *druid, GnomeDruidPage *page);

void       gnome_druid_insert_page           (GnomeDruid *druid, GnomeDruidPage *back_page, GnomeDruidPage *page);

void       gnome_druid_append_page           (GnomeDruid *druid, GnomeDruidPage *page);

void	   gnome_druid_set_page              (GnomeDruid *druid, GnomeDruidPage *page);

/* gnome-druide-page */

gboolean gnome_druid_page_next     (GnomeDruidPage *druid_page);
void     gnome_druid_page_prepare  (GnomeDruidPage *druid_page);
gboolean gnome_druid_page_back     (GnomeDruidPage *druid_page);
gboolean gnome_druid_page_cancel   (GnomeDruidPage *druid_page);
void     gnome_druid_page_finish   (GnomeDruidPage *druid_page);


/* gnome-druid-page-standard */
new GtkWidget *gnome_druid_page_standard_new           (void);

new GtkWidget *gnome_druid_page_standard_new_with_vals (const gchar *title, GdkImlibImage *logo); 

void gnome_druid_page_standard_set_bg_color (GnomeDruidPageStandard *druid_page_standard, GdkColor *color);
void gnome_druid_page_standard_set_logo_bg_color   (GnomeDruidPageStandard *druid_page_standard, GdkColor *color);
void gnome_druid_page_standard_set_title_color     (GnomeDruidPageStandard *druid_page_standard, GdkColor *color);
void gnome_druid_page_standard_set_title           (GnomeDruidPageStandard *druid_page_standard, const gchar *title);

/* access on stand page */
GtkWidget GnomeDruidPageStandard->vbox;


void gnome_druid_page_standard_set_logo            (GnomeDruidPageStandard *druid_page_standard, GdkImlibImage *logo_image); 

new GtkWidget *gnome_druid_page_start_new         (void);
new GtkWidget *gnome_druid_page_start_new_with_vals(const gchar *title,
						    const gchar* text,
						    GdkImlibImage *logo,
						    GdkImlibImage *watermark);

void gnome_druid_page_start_set_bg_color      (GnomeDruidPageStart *druid_page_start,
					       GdkColor *color);
void gnome_druid_page_start_set_textbox_color (GnomeDruidPageStart *druid_page_start,
					       GdkColor *color);
void gnome_druid_page_start_set_logo_bg_color (GnomeDruidPageStart *druid_page_start,
					       GdkColor *color);
void gnome_druid_page_start_set_title_color   (GnomeDruidPageStart *druid_page_start,
					       GdkColor *color);
void gnome_druid_page_start_set_text_color    (GnomeDruidPageStart *druid_page_start,
					       GdkColor *color);
void gnome_druid_page_start_set_text          (GnomeDruidPageStart *druid_page_start,
					       const gchar *text);
void gnome_druid_page_start_set_title         (GnomeDruidPageStart *druid_page_start,
					       const gchar *title);
void gnome_druid_page_start_set_logo          (GnomeDruidPageStart *druid_page_start,
					       GdkImlibImage *logo_image);

void gnome_druid_page_start_set_watermark     (GnomeDruidPageStart *druid_page_start,
					       GdkImlibImage *watermark);


new GtkWidget *gnome_druid_page_finish_new         (void);
new GtkWidget *gnome_druid_page_finish_new_with_vals(const gchar *title,
						     const gchar* text,
						     GdkImlibImage *logo,
						     GdkImlibImage *watermark);

void gnome_druid_page_finish_set_bg_color      (GnomeDruidPageFinish *druid_page_finish,
					       GdkColor *color);
void gnome_druid_page_finish_set_textbox_color (GnomeDruidPageFinish *druid_page_finish,
					       GdkColor *color);
void gnome_druid_page_finish_set_logo_bg_color (GnomeDruidPageFinish *druid_page_finish,
					       GdkColor *color);
void gnome_druid_page_finish_set_title_color   (GnomeDruidPageFinish *druid_page_finish,
					       GdkColor *color);
void gnome_druid_page_finish_set_text_color    (GnomeDruidPageFinish *druid_page_finish,
					       GdkColor *color);
void gnome_druid_page_finish_set_text          (GnomeDruidPageFinish *druid_page_finish,
					       const gchar *text);
void gnome_druid_page_finish_set_title         (GnomeDruidPageFinish *druid_page_finish,
					       const gchar *title);
void gnome_druid_page_finish_set_logo          (GnomeDruidPageFinish *druid_page_finish,
					       GdkImlibImage *logo_image);

void gnome_druid_page_finish_set_watermark     (GnomeDruidPageFinish *druid_page_finish,
					       GdkImlibImage *watermark);


