/*
** gnome-stock signature file
*/
module gnome_stock;

#include <gnome.h>

typedef GtkObject GnomeStock;

new GtkWidget    *gnome_stock_new(void);

new GtkWidget    *gnome_stock_new_with_icon(const char *icon);

gboolean         gnome_stock_set_icon(GnomeStock *stock, const char *icon);

new GtkWidget    *gnome_stock_pixmap_widget   (GtkWidget *window,
                                                    const char *icon);

new GtkWidget    *gnome_stock_pixmap_widget_at_size(GtkWidget *window,
							     const char *icon,
							     guint width,
							     guint height);

new GtkWidget    *gnome_pixmap_button         (GtkWidget *pixmap,
					       const char *text);
void		 gnome_button_can_default    (GtkButton *button,
					      gboolean can_default);

new GtkWidget    *gnome_stock_button          (const char *type);

new GtkWidget        *gnome_stock_or_ordinary_button (const char *type);

new GtkWidget        *gnome_stock_menu_item       (const char *type,
					       const char *text);




/* To customize the accelerators add a file ~/.gnome/GnomeStock, wich looks
 * like that:
 *
 * [Accelerators]
 * Menu_New=Shft+Ctl+N
 * Menu_About=Ctl+A
 * Menu_Save As=Ctl+Shft+S
 * Menu_Quit=Alt+X
 */

gboolean	       gnome_stock_menu_accel      (const char *type,
						    guchar *key,
						    guint8 *mod);

void                   gnome_stock_menu_accel_parse(const char *section);

new GtkWidget *gnome_stock_transparent_window (const char *icon, const char *subtype);

void gnome_stock_pixmap_gdk (const char *icon,
	 		     const char *subtype,
			     out GdkPixmap *pixmap,
			     out GdkPixmap *mask); 

