#include <stdlib.h>

#include <GL/gl.h>
#include <gtkgl/gtkglarea.h>
#include "gtk_drv_api.h"

typedef struct {
    int size;
    GLuint buffer[1];
} PickBuf;


void gdrv_gtk_gl_area_get_pick_buf(GtkGLArea* glarea, GtkArray* arr)
{
    PickBuf* buf;

    if ((buf = (PickBuf*) gtk_object_get_data((GtkObject*) glarea,
					      "pick_buf")) != NULL) {
	arr->size = buf->size;
	arr->vector = gdrv_stack_alloc(arr->size*sizeof(GLuint));
	memcpy(arr->vector, buf->buffer, arr->size*sizeof(GLuint));
    }
    else {
	arr->size = 0;
	arr->vector = NULL;
    }
}

void  gdrv_gtk_gl_area_set_pick_buf(GtkGLArea* glarea)
{
    PickBuf* buf;

    if ((buf = (PickBuf*) gtk_object_get_data((GtkObject*) glarea,
					      "pick_buf")) != NULL)
	glSelectBuffer(buf->size, (void*) buf->buffer);
    else
	glSelectBuffer(0, NULL);
}

void  gdrv_gtk_gl_area_new_pick_buf(GtkGLArea* glarea, GLsizei size)
{
    PickBuf* buf;
    int sz = sizeof(PickBuf) + sizeof(GLuint)*size;

    if ((buf = (PickBuf*) gtk_object_get_data((GtkObject*) glarea,
					      "pick_buf")) != NULL)
	buf = (PickBuf*) realloc(buf, sz);
    else
	buf = (PickBuf*) malloc(sz);
    buf->size = size;
    /* does set_data destory old ??? we will find out in the core i guess */
    gtk_object_set_data_full((GtkObject*) glarea, "pick_buf",
			     (gpointer) buf,
			     (GtkDestroyNotify) free);
}
