%%
%% GLU definitions
%%
-ifndef(GLU_HRL).
-define(GLU_HRL, true).

-include_lib("erlgtk/include/gl.hrl").
-include_lib("erlgtk/include/libglu.hrl").

-define(GLU_VERSION_1_1,  1).
-define(GLU_TRUE          ?GL_TRUE).
-define(GLU_FALSE         ?GL_FALSE).

%% Normal vectors 
-define(GLU_SMOOTH,	100000).
-define(GLU_FLAT,	100001).
-define(GLU_NONE,	100002).

%% Quadric draw styles 
-define(GLU_POINT,	100010).
-define(GLU_LINE,	100011).
-define(GLU_FILL,	100012).
-define(GLU_SILHOUETTE,	100013).

%% Quadric orientation 
-define(GLU_OUTSIDE,	100020).
-define(GLU_INSIDE,	100021).

%% Tesselator 
-define(GLU_BEGIN,	100100).
-define(GLU_VERTEX,	100101).
-define(GLU_END,	100102).
-define(GLU_ERROR,	100103).
-define(GLU_EDGE_FLAG,	100104).

%% Contour types 
-define(GLU_CW,		100120).
-define(GLU_CCW,	100121).
-define(GLU_INTERIOR,	100122).
-define(GLU_EXTERIOR,	100123).
-define(GLU_UNKNOWN,	100124).

%% Tesselation errors 
-define(GLU_TESS_ERROR1, 100151).  %% missing gluEndPolygon 
-define(GLU_TESS_ERROR2  100152,  %% missing gluBeginPolygon 
-define(GLU_TESS_ERROR3, 100153).  %% misoriented contour 
-define(GLU_TESS_ERROR4, 100154).  %% vertex/edge intersection 
-define(GLU_TESS_ERROR5, 100155).  %% misoriented or self-intersecting loops 
-define(GLU_TESS_ERROR6, 100156).  %% coincident vertices 
-define(GLU_TESS_ERROR7, 100157).  %% all vertices collinear 
-define(GLU_TESS_ERROR8, 100158).  %% intersecting edges 
-define(GLU_TESS_ERROR9, 100159).  %% not coplanar contours 

%% NURBS 
-define(GLU_AUTO_LOAD_MATRIX,	100200).
-define(GLU_CULLING,		100201).
-define(GLU_PARAMETRIC_TOLERANCE, 100202).
-define(GLU_SAMPLING_TOLERANCE,	100203).
-define(GLU_DISPLAY_MODE,	100204).
-define(GLU_SAMPLING_METHOD,	100205).
-define(GLU_U_STEP,		100206).
-define(GLU_V_STEP,		100207).

-define(GLU_PATH_LENGTH,		100215).
-define(GLU_PARAMETRIC_ERROR,	100216).
-define(GLU_DOMAIN_DISTANCE,	100217).

-define(GLU_MAP1_TRIM_2,		100210).
-define(GLU_MAP1_TRIM_3,		100211).

-define(GLU_OUTLINE_POLYGON,	100240).
-define(GLU_OUTLINE_PATCH,	100241).

-define(GLU_NURBS_ERROR1  100251).   %% spline order un-supported 
-define(GLU_NURBS_ERROR2,  100252).   %% too few knots 
-define(GLU_NURBS_ERROR3,  100253).   %% valid knot range is empty 
-define(GLU_NURBS_ERROR4,  100254).   %% decreasing knot sequence 
-define(GLU_NURBS_ERROR5,  100255).   %% knot multiplicity > spline order 
-define(GLU_NURBS_ERROR6,  100256).   %% endcurve() must follow bgncurve() 
-define(GLU_NURBS_ERROR7,  100257).   %% bgncurve() must precede endcurve() 
-define(GLU_NURBS_ERROR8,  100258).   %% ctrlarray or knot vector is NULL 
-define(GLU_NURBS_ERROR9,  100259).   %% can't draw pwlcurves 
-define(GLU_NURBS_ERROR10, 100260).   %% missing gluNurbsCurve() 
-define(GLU_NURBS_ERROR11, 100261).   %% missing gluNurbsSurface() 
-define(GLU_NURBS_ERROR12, 100262).   %% endtrim() must precede endsurface() 
-define(GLU_NURBS_ERROR13, 100263).   %% bgnsurface() must precede endsurface() 
-define(GLU_NURBS_ERROR14, 100264).   %% curve of improper type passed as trim curve 
-define(GLU_NURBS_ERROR15, 100265).   %% bgnsurface() must precede bgntrim() 
-define(GLU_NURBS_ERROR16, 100266).   %% endtrim() must follow bgntrim() 
-define(GLU_NURBS_ERROR17, 100267).   %% bgntrim() must precede endtrim()
-define(GLU_NURBS_ERROR18, 100268).   %% invalid or missing trim curve
-define(GLU_NURBS_ERROR19, 100269).   %% bgntrim() must precede pwlcurve() 
-define(GLU_NURBS_ERROR20, 100270).   %% pwlcurve referenced twice
-define(GLU_NURBS_ERROR21, 100271).   %% pwlcurve and nurbscurve mixed 
-define(GLU_NURBS_ERROR22, 100272).   %% improper usage of trim data type 
-define(GLU_NURBS_ERROR23, 100273).   %% nurbscurve referenced twice 
-define(GLU_NURBS_ERROR24, 100274).   %% nurbscurve and pwlcurve mixed 
-define(GLU_NURBS_ERROR25, 100275).   %% nurbssurface referenced twice 
-define(GLU_NURBS_ERROR26, 100276).   %% invalid property 
-define(GLU_NURBS_ERROR27, 100277).   %% endsurface() must follow bgnsurface() 
-define(GLU_NURBS_ERROR28, 100278).   %% intersecting or misoriented trim curves 
-define(GLU_NURBS_ERROR29, 100279).   %% intersecting trim curves 
-define(GLU_NURBS_ERROR30, 100280).   %% UNUSED 
-define(GLU_NURBS_ERROR31, 100281).   %% unconnected trim curves 
-define(GLU_NURBS_ERROR32, 100282).   %% unknown knot error 
-define(GLU_NURBS_ERROR33, 100283).   %% negative vertex count encountered 
-define(GLU_NURBS_ERROR34, 100284).   %% negative byte-stride 
-define(GLU_NURBS_ERROR35, 100285).   %% unknown type descriptor 
-define(GLU_NURBS_ERROR36, 100286).   %% null control point reference 
-define(GLU_NURBS_ERROR37, 100287).   %% duplicate point on pwlcurve 

%% Errors 
-define(GLU_INVALID_ENUM,		100900).
-define(GLU_INVALID_VALUE,		100901).
-define(GLU_OUT_OF_MEMORY,		100902).
-define(GLU_INCOMPATIBLE_GL_VERSION,	100903).

%% New in GLU 1.1 
-define(GLU_VERSION,	100800).
-define(GLU_EXTENSIONS,	100801).


-endif.

